#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define F first
#define S second
//everything goes according to the plan
#define pb push_back

using namespace std;
         
const int N = 5e5+2;
const int inf = 1e9;
            
vector <string> a;
           
int n, m;
                                 
struct point {
	int x, y;
	point () {x = y = -1;}
	point (int i, int j) {
		x = i;
		y = j;
	}       
	inline bool exist () {  
		return (x >= 0 && y >= 0);
	} 
	inline void print () {
		cout << x+1 << ' ' << y+1;
	}	
};    

vector < vector <point> > l[3], r[3], u[3], d[3];

inline int dist (point a, point b) {
	return abs(a.x - b.x) + abs(a.y - b.y);
}	

inline void solve (int x, int y) {
	int mn = inf;
	point ansx, ansy;
	vector <point> col, row;
	for (int k = 1;k <= 2;k ++) {
		if (u[k][x][y].exist())
			col.pb (u[k][x][y]);
		if (d[k][x][y].exist ())
			col.pb (d[k][x][y]);
		if (l[k][x][y].exist ())
			row.pb (l[k][x][y]);
		if (r[k][x][y].exist())
			row.pb (r[k][x][y]);
	}
	for (auto i : col) {
		for (auto j : row) {            
			if (a[i.x][i.y] != a[j.x][j.y] && mn > dist (i, j)) {
				mn = dist (i, j);
				ansx = i;
				ansy = j;
			}	
		}
	}
	if (mn == inf)	cout << -1;
		else
		{
			ansx.print();
			cout << ' ';
			ansy.print();
		}	
	cout << endl;	
}	
	

int main () 
{
	ios_base::sync_with_stdio (0);
	cin.tie (0);

	cin >> n >> m;
	
	a.resize (n);
	for (int k = 1;k <= 2;k ++)
	{
		l[k].resize (n);
		r[k].resize (n);
		u[k].resize (n);
		d[k].resize (n);
	}	
	
	for (int i = 0;i < n;i ++) {	
		cin >> a[i];
		for (int k = 1;k <= 2;k ++) {
			l[k][i].resize (m);
			r[k][i].resize (m);
			u[k][i].resize (m);
			d[k][i].resize (m);
		}	
	}              
	for (int i = 0;i < n;i ++) {       
		pair <char, point> x, y;
		x.F = y.F = 0;
		x.S = y.S = point();
		for (int j = 0;j < m;j ++) {
			l[1][i][j] = x.S;
			l[2][i][j] = y.S;
			if (y.F == a[i][j]) {
				y = x;
				x = mp (a[i][j], point (i, j));
			}
				else
				{
					if (x.F != a[i][j])
						y = x, x = mp (a[i][j], point (i, j));
							else
								x = mp (a[i][j], point (i, j));
				}		
		}
		x.F = y.F = 0;
		x.S = y.S = point();
		for (int j = m-1;j >= 0;j --) {
			r[1][i][j] = x.S;
			r[2][i][j] = y.S;
			if (y.F == a[i][j]) {
				y = x;
				x = mp (a[i][j], point (i, j));
			}
				else
				{
					if (x.F != a[i][j])
						y = x, x = mp (a[i][j], point (i, j));
							else
								x = mp (a[i][j], point (i, j));
				}		
		}
	}
	for (int j = 0;j < m;j ++) {
		pair <char, point> x, y;
		x.F = y.F = 0;
		x.S = y.S = point();
		for (int i = 0;i < n;i ++) {
			u[1][i][j] = x.S;
			u[2][i][j] = y.S;
			if (y.F == a[i][j]) {
				y = x;
				x = mp (a[i][j], point (i, j));
			}
				else
				{
					if (x.F != a[i][j])
						y = x, x = mp (a[i][j], point (i, j));
							else
								x = mp (a[i][j], point (i, j));
				}		
		}                       
		x.F = y.F = 0;
		y.S = point();
		x.S = point();

		for (int i = n-1;i >= 0;i --) {
			d[1][i][j] = x.S;
			d[2][i][j] = y.S;
			if (y.F == a[i][j]) {
				y = x;
				x = mp (a[i][j], point (i, j));
			}
				else
				{
					if (x.F != a[i][j])
						y = x, x = mp (a[i][j], point (i, j));
							else
								x = mp (a[i][j], point (i, j));
				}		
		}
	}	      
	int q;	cin >> q;
	while (q --) {
		int x, y;	cin >> x >> y;
		x --, y --;

		solve (x, y);
 	}	
					
	return 0;
} 