#include <bits/stdc++.h>

#define F first
#define S second
#define mp make_pair
#define pb push_back

const int INF = 1e8;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    vector<vector<vector<int> > > x(26, vector<vector<int> >(n, vector<int>(m, -INF)));
    vector<vector<vector<int> > > y(26, vector<vector<int> >(n, vector<int>(m, -INF)));
    vector<string> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        vector<int> t(26, -INF);
        for (int j = 0; j < m; j++) {
            for (int z = 0; z < 26; z++) if (abs(j - t[z]) < abs(j - x[z][i][j])) x[z][i][j] = t[z];
            t[v[i][j] - 'a'] = j;
        }
        t.assign(26, -INF);
        for (int j = m - 1; j >= 0; j--) {
            for (int z = 0; z < 26; z++) if (abs(j - t[z]) < abs(j - x[z][i][j])) x[z][i][j] = t[z];
            t[v[i][j] - 'a'] = j;
        }
    }
    for (int j = 0; j < m; j++) {
        vector<int> t(26, -INF);
        for (int i = 0; i < n; i++) {
            for (int z = 0; z < 26; z++) if (abs(i - t[z]) < abs(i - y[z][i][j])) y[z][i][j] = t[z];
            t[v[i][j] - 'a'] = i;
        }
        t.assign(26, -INF);
        for (int i = n - 1; i >= 0; i--) {
            for (int z = 0; z < 26; z++) if (abs(i - t[z]) < abs(i - y[z][i][j])) y[z][i][j] = t[z];
            t[v[i][j] - 'a'] = i;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int i, j;
        cin >> i >> j;
        i--;
        j--;
        tuple<int, int, int> ans(INF, -1, -1);
        for (int f = 0; f < 26; f++) {
            for (int z = 0; z < 26; z++) {
                if (f == z) continue;
                if (x[f][i][j] == -INF) continue;
                if (y[z][i][j] == -INF) continue;
                ans = min(ans, make_tuple(abs(j - x[f][i][j]) + abs(i - y[z][i][j]), y[z][i][j], x[f][i][j]));
            }
        }
        if (get<0>(ans) == INF) {
            cout << -1 << "\n";
            continue;
        }
        cout << i + 1 << " " << get<2>(ans) + 1 << " " << get<1>(ans) + 1 << " " << j + 1 << "\n";
    }
    return 0;
}
