#include <bits/stdc++.h>

#define F first
#define S second
#define mp make_pair
#define pb push_back

const int INF = 1e8;

using namespace std;

vector<string> v;

int it;
tuple<int, int, char> we[100];

pair<int, int> processwe() {
    pair<int, int> res(-INF, -INF);
    sort(we, we + it);
    for (int i = 0; i < it; i++) {
        bool skip = false;
        for (int j = 0; j < i; j++) if (get<2>(we[j]) == get<2>(we[i])) {
            skip = true;
            break;
        }
        if (skip) continue;
        if (res.F == -INF) res.F = get<1>(we[i]);
        else {
            res.S = get<1>(we[i]);
            break;
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> x(n, vector<pair<int, int> >(m, mp(-INF, -INF)));
    vector<vector<pair<int, int>>> y(n, vector<pair<int, int> >(m, mp(-INF, -INF)));
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        pair<int, int> tt(-INF, -INF);
        for (int j = 0; j < m; j++) {
            char cur = v[i][j];
            x[i][j] = tt;
            if (tt.F != -INF && v[i][tt.F] == cur) {
                tt.F = j;
                continue;
            }
            if (tt.S != -INF && v[i][tt.S] == cur) {
                swap(tt.F, tt.S);
                tt.F = j;
                continue;
            }
            tt.S = j;
            swap(tt.F, tt.S);
        }
        tt = mp(-INF, -INF);
        for (int j = m - 1; j >= 0; j--) {
            char cur = v[i][j];
            it = 0;

            auto tf = x[i][j];

            if (tt.F != -INF) we[it++] = make_tuple(abs(tt.F - j), tt.F, v[i][tt.F]);
            if (tt.S != -INF) we[it++] = make_tuple(abs(tt.S - j), tt.S, v[i][tt.S]);
            if (tf.F != -INF) we[it++] = make_tuple(abs(tf.F - j), tf.F, v[i][tf.F]);
            if (tf.S != -INF) we[it++] = make_tuple(abs(tf.S - j), tf.S, v[i][tf.S]);

            x[i][j] = processwe();

            if (tt.F != -INF && v[i][tt.F] == cur) {
                tt.F = j;
                continue;
            }
            if (tt.S != -INF && v[i][tt.S] == cur) {
                swap(tt.F, tt.S);
                tt.F = j;
                continue;
            }
            tt.S = j;
            swap(tt.F, tt.S);
        }
    }
    for (int j = 0; j < m; j++) {
        pair<int, int> tt(-INF, -INF);
        for (int i = 0; i < n; i++) {
            char cur = v[i][j];
            y[i][j] = tt;
            if (tt.F != -INF && v[tt.F][j] == cur) {
                tt.F = i;
                continue;
            }
            if (tt.S != -INF && v[tt.S][j] == cur) {
                swap(tt.F, tt.S);
                tt.F = i;
                continue;
            }
            tt.S = i;
            swap(tt.F, tt.S);
        }
        tt = mp(-INF, -INF);
        for (int i = n - 1; i >= 0; i--) {
            char cur = v[i][j];
            it = 0;

            auto tf = y[i][j];

            if (tt.F != -INF) we[it++] = make_tuple(abs(tt.F - i), tt.F, v[tt.F][j]);
            if (tt.S != -INF) we[it++] = make_tuple(abs(tt.S - i), tt.S, v[tt.S][j]);
            if (tf.F != -INF) we[it++] = make_tuple(abs(tf.F - i), tf.F, v[tf.F][j]);
            if (tf.S != -INF) we[it++] = make_tuple(abs(tf.S - i), tf.S, v[tf.S][j]);

            y[i][j] = processwe();

            if (tt.F != -INF && v[tt.F][j] == cur) {
                tt.F = i;
                continue;
            }
            if (tt.S != -INF && v[tt.S][j] == cur) {
                swap(tt.F, tt.S);
                tt.F = i;
                continue;
            }
            tt.S = i;
            swap(tt.F, tt.S);
        }
    }

//    cerr << "x" << endl;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            cerr << "(" << x[i][j].F << " " << x[i][j].S << ") ";
//        }
//        cerr << endl;
//    }
//    cerr << "y" << endl;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            cerr << "(" << y[i][j].F << " " << y[i][j].S << ") ";
//        }
//        cerr << endl;
//    }

    int q;
    cin >> q;
    while (q--) {
        int i, j;
        cin >> i >> j;
        i--;
        j--;
        tuple<int, int, int> ans(INF, -1, -1);

        if (x[i][j].F != -INF && y[i][j].F != -INF && v[i][x[i][j].F] != v[y[i][j].F][j]) ans = min(ans, make_tuple(abs(j - x[i][j].F) + abs(i - y[i][j].F), x[i][j].F, y[i][j].F));
        if (x[i][j].S != -INF && y[i][j].F != -INF && v[i][x[i][j].S] != v[y[i][j].F][j]) ans = min(ans, make_tuple(abs(j - x[i][j].S) + abs(i - y[i][j].F), x[i][j].S, y[i][j].F));
        if (x[i][j].F != -INF && y[i][j].S != -INF && v[i][x[i][j].F] != v[y[i][j].S][j]) ans = min(ans, make_tuple(abs(j - x[i][j].F) + abs(i - y[i][j].S), x[i][j].F, y[i][j].S));
        if (x[i][j].S != -INF && y[i][j].S != -INF && v[i][x[i][j].S] != v[y[i][j].S][j]) ans = min(ans, make_tuple(abs(j - x[i][j].S) + abs(i - y[i][j].S), x[i][j].S, y[i][j].S));

        if (get<0>(ans) == INF) {
            cout << -1 << "\n";
            continue;
        }
        //cerr << a
        cout << i + 1 << " " << get<1>(ans) + 1 << " " << get<2>(ans) + 1 << " " << j + 1 << "\n";
    }
    return 0;
}
