#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

using namespace std;

int get(long long a) {
	unordered_set < long long > q;
	for (int i = 1; i * i < a; i++) {
		if (a % i == 0) {
			q.insert(i);
			q.insert(a / i);
		}
	}
	return q.size();
}

int main() {
	long long x;
	cin >> x;
	if (x <= 8e7) {
		for (int i = 0; i * 100 <= x; i++) {
			if (get(x + i) >= 100) {
				cout << x + i;
				return 0;
			}
		}
		cout << -1;
		return 0;
	}
	long long ans = 2 * 3 * 5 * 7 * 11 * 13 * 17;
	long long q = x / ans;
	if (x % ans)
		q++;
	cout << q * ans;
	return 0;
}
