#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:25600000")
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

#define TASK ""

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	return solve();
};

const int MAXS = 1e6 + 1;//!!!!!!!!!!!!!
const int INF = 1e9;

struct mystr{
	vector<int> str, col, nstr, ncol;

	mystr(){
		str.assign(26, INF);
		col.assign(26, INF);
		nstr.assign(26, INF);
		ncol.assign(26, INF);
	}
} a[MAXS];

struct strans{
	int r1, c1, r2, c2;
} out[MAXS];

int n, m, q;
char matr[MAXS];
bool g[MAXS];

int get(int i, int j){
	return i * m + j;
}

bool uin(int &x, int y){
	if (y < x){
		x = y;
		return true;
	}
	return false;
}

int pref[26];
int suff[26];
int prefwho[26];
int suffwho[26];
int ansstr[26];
int answho[26];
pair<int, int> asks[MAXS];

int solve() {
	
	scanf("%d%d", &n, &m);
	int num = -1;
	for (int i = 0; i < n; i++){
		scanf("\n");
		for (int j = 0; j < m; j++){
			num++;
			char c;
			scanf("%c", &c);
			matr[num] = c;
		}
	}
	scanf("%d", &q);
	for (int it = 0; it < q; it++){
		int x, y;
		scanf("%d%d", &x, &y);
		x--, y--;
		asks[it] = { x, y };
		int num2 = get(x, y);
		g[num2] = true;
	}
	for (int i = 0; i < n; i++){
		for (int j = 0; j < m; j++){
			int num = get(i, j);
			for (int x = 0; x < 26; x++){
				if (j) uin(a[num].str[x], a[num - 1].str[x] + 1);
				if (i) uin(a[num].col[x], a[num - m].col[x] + 1);
			}
			if (j) uin(a[num].str[matr[num - 1] - 'a'], 1);
			if (i) uin(a[num].col[matr[num - m] - 'a'], 1);
		}
	}
	//reverse
	for (int i = n - 1; i >= 0; i--){
		for (int j = m - 1; j >= 0; j--){
			int num = get(i, j);
			for (int x = 0; x < 26; x++){
				if (j < m - 1) uin(a[num].nstr[x], a[num + 1].nstr[x] + 1);
				if (i < n - 1) uin(a[num].ncol[x], a[num + m].ncol[x] + 1);
			}
			if (j < m - 1) uin(a[num].nstr[matr[num + 1] - 'a'], 1);
			if (i < n - 1) uin(a[num].ncol[matr[num + m] - 'a'], 1);
		}
	}
	num = -1;
	for (int i = 0; i < n; i++){
		for (int j = 0; j < m; j++){
			num++;
			if (g[num]) {
				for (int x = 0; x < 26; x++){
					uin(a[num].str[x], a[num].nstr[x]);
					uin(a[num].col[x], a[num].ncol[x]);
				}
				/*a[num].nstr.clear();
				a[num].ncol.clear();*/
			}
		}
	}

	num = -1;
	for (int i = 0; i < n; i++){
		for (int j = 0; j < m; j++){
			num++;
			if (g[num]){
				fill(ansstr, ansstr + 26, INF);
				fill(answho, answho + 26, -1);
				pref[0] = a[num].str[0], prefwho[0] = 0;
				suff[25] = a[num].str[25], suffwho[25] = 25;
				for (int x = 1; x < 26; x++){
					prefwho[x] = x, pref[x] = a[num].str[x];
					if (uin(pref[x], pref[x - 1])){
						prefwho[x] = prefwho[x - 1];
					}
				}
				for (int x = 24; x >= 0; x--){
					suffwho[x] = x, suff[x] = a[num].str[x];
					if (uin(suff[x], suff[x + 1])){
						suffwho[x] = suffwho[x + 1];
					}
				}
				for (int x = 0; x < 26; x++){
					int dpref = x == 0 ? INF : pref[x - 1];
					int dsuff = x == 25 ? INF : suff[x + 1];
					if (dpref == dsuff && dpref == INF) continue;
					if (dpref < dsuff){
						ansstr[x] = pref[x - 1];
						answho[x] = prefwho[x - 1];
					}
					else{
						ansstr[x] = suff[x + 1];
						answho[x] = suffwho[x + 1];
					}
				}
				int answer = INF, ansx = 0;
				for (int x = 0; x < 26; x++){
					int nans = ansstr[x] + a[num].col[x];
					if (nans < answer){
						answer = nans;
						ansx = x;
					}
				}
				if (answer == INF){
					out[num] = { -1, -1, -1, -1 };
					continue;
				}
				out[num] = { i, -1, -1, j };
				int dt = ansstr[ansx];
				if (j - dt >= 0 && matr[num - dt] == 'a' + answho[ansx]){
					out[num].c1 = j - dt;
				}
				else {
					out[num].c1 = j + dt;
				}
				
				dt = a[num].col[ansx];
				if (i - dt >= 0 && matr[num - m * dt] == 'a' + ansx){
					out[num].r2 = i - dt;
				}
				else{
					out[num].r2 = i + dt;
				}
			}
		}
	}

	for (int i = 0; i < q; i++){
		int num = get(asks[i].first, asks[i].second);
		if (out[num].c1 == -1){
			printf("-1\n");
		}
		else{
			printf("%d %d %d %d\n", out[num].r1 + 1, out[num].c1 + 1, out[num].r2 + 1, out[num].c2 + 1);
		}
	}
	return 0;
}
