#include <iostream>
#include <vector>
#include <algorithm>

#define fi first
#define se second
using namespace std;
typedef long long ll;

ll step17[5005], step19[5005];

const ll mod = 1000000007;

int main() {
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
    int h, w, n;
    cin >> h >> w >> n;
    string s;
    cin >> s;
    step17[0] = 1;
    step19[0] = 1;
    for (int i = 1; i <= 5000; i++) {
        step17[i] = (step17[i - 1] * 17) % mod;
        step19[i] = (step19[i - 1] * 19) % mod;
    }
    vector< vector<int> > g(4);
    for (int i = 0; i < 4; i++) {
        int k;
        cin >> k;
        g[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> g[i][j];
        }
    }
    vector< vector<int> > z(4);
    for (int i = 0; i < 4; i++) {
        z[i].resize(n);
        for (int j = 0; j < g[i].size(); j++) {
            z[i][j] = g[i][j];
        }
        for (int j = g[i].size(); j < n; j++) {
            if (i % 2 == 0)
                z[i][j] = (10007 * z[i][j - 2] + 10009 * z[i][j - 1] + 87277) % h;
            else
                z[i][j] = (10007 * z[i][j - 2] + 10009 * z[i][j - 1] + 87277) % w;
        }
    }
    vector< vector<int> > v(h, vector<int> (w));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            v[i][j] = i * w + j;
        }
    }

    vector<int> real(w + 1);
    for (int i = 0; i < w; i++) {
        real[i] = i;
    }
    for (int q = 0; q < n; q++) {
        if (s[q] == 'c') {
            swap(real[z[1][q]], real[z[3][q]]);
        }
        if (s[q] == 'r') {
            v[z[0][q]].swap(v[z[2][q]]);
        }
        if (s[q] == 'f') {
            swap(v[z[0][q]][real[z[1][q]]], v[z[2][q]][real[z[3][q]]]);
        }
    }
    ll sum = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            sum += (((v[i][real[j]] * step17[i]) % mod ) * step19[j]) % mod;
        }
    }
    cout << sum;
}
