#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;


ll cnt;


ll norm(ll a) {
	while (a > cnt) a -= cnt;
	while (a <= 0) a += cnt;
	return a;
}

ll check(ll a) {
	cout << "? " << norm(a) << endl;
	cin >> a;
	return a;
}


ll ans(ll a) {
	cout << "! " << norm(a) << endl;
	exit(0);
}

int run() {
	ll x, m;
	cin >> x >> m;
	cnt = (ll)1e+18 - m;
	ll d = check(1);
	if (d == x) ans(1);
	d--;
	ll l = x - m -d - 4;
	ll r = x - d;
	while (r >= l) {
		ll m = (l + r) / 2;
		ll f = check(m);
		if (f == x) ans(m);
		else if (f - x > 3000) l = m + 1;
		else if (x - f > 3000) r = m - 1;
		else if (f > x) r = m - 1;
		else l = m + 1;
	}
	cout << "! -1" << endl;
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}