#include <stdio.h>
#include <vector>
#include <iostream>


#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)

using namespace std;

void print(vector<int> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}



const int INF = (int)1e9 + 7;
int kek = 26;




int main()
{
    //freopen("a.in", "r", stdin);
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    int n, m;
    scanf("%d%d", &n, &m);
    int gor[n][m][2][3];
    int vert[m][n][2][3];
    char s[n][m];
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            for (int k = 0; k < 2; k++){
                gor[i][j][k][0] = INF;
                gor[i][j][k][1] = INF;
                gor[i][j][k][2] = INF;
                vert[j][i][k][0] = INF;
                vert[j][i][k][1] = INF;
                vert[j][i][k][2] = INF;
            }
        }
    }
    vector<int> dist(kek);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            scanf(" %c", &s[i][j]);
    for (int i = 0; i < n; i++){
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = 0; j < m; j++){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    if (j - dist[k] <= gor[i][j][0][0] && dist[k] != gor[i][j][0][1]){
                        if (gor[i][j][0][2] != k)
                            for (int kekich = 0; kekich < 3; kekich++)
                                gor[i][j][1][kekich] = gor[i][j][0][kekich];
                            gor[i][j][0][0] = j - dist[k];
                            gor[i][j][0][1] = dist[k];
                            gor[i][j][0][2] = k;
                            continue;
                    }
                    if (j - dist[k] < gor[i][j][1][0] && k != gor[i][j][0][2] && dist[k] != gor[i][j][0][1]){
                        gor[i][j][1][0] = j - dist[k];
                        gor[i][j][1][1] = dist[k];
                        gor[i][j][1][2] = k;
                    }
                }
            }
            dist[int(s[i][j] - 'a')] = j;
        }
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = m - 1; j >= 0; j--){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    if (dist[k] - j <= gor[i][j][0][0] && dist[k] != gor[i][j][0][1]){
                        if (gor[i][j][0][2] != k)
                            for (int kekich = 0; kekich < 3; kekich++)
                                gor[i][j][1][kekich] = gor[i][j][0][kekich];
                        gor[i][j][0][0] = j - dist[k];
                        gor[i][j][0][1] = dist[k];
                        gor[i][j][0][2] = k;
                        continue;
                    }
                    if (dist[k] - j < gor[i][j][1][0] && k != gor[i][j][0][2] && dist[k] != gor[i][j][0][1]){
                        gor[i][j][1][0] = j - dist[k];
                        gor[i][j][1][1] = dist[k];
                        gor[i][j][1][2] = k;
                    }
                }
            }
            dist[int(s[i][j] - 'a')] = j;
        }
    }

    for (int i = 0; i < m; i++){
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = 0; j < n; j++){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    if (j - dist[k] <= vert[i][j][0][0] && dist[k] != vert[i][j][0][1]){
                        if (vert[i][j][0][2] != k)
                            for (int kekich = 0; kekich < 3; kekich++)
                                vert[i][j][1][kekich] = vert[i][j][0][kekich];
                        vert[i][j][0][0] = j - dist[k];
                        vert[i][j][0][1] = dist[k];
                        vert[i][j][0][2] = k;
                        continue;
                    }
                    if (j - dist[k] < vert[i][j][1][0] && k != vert[i][j][0][2] && dist[k] != vert[i][j][0][1]){
                        vert[i][j][1][0] = j - dist[k];
                        vert[i][j][1][1] = dist[k];
                        vert[i][j][1][2] = k;                    }
                }
            }
            dist[int(s[j][i] - 'a')] = j;
        }
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = n - 1; j >= 0; j--){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    if (dist[k] - j <= vert[i][j][0][0] && dist[k] != vert[i][j][0][1]){
                        if (vert[i][j][0][2] != k)
                            for (int kekich = 0; kekich < 3; kekich++)
                                vert[i][j][1][kekich] = vert[i][j][0][kekich];
                        vert[i][j][0][0] = j - dist[k];
                        vert[i][j][0][1] = dist[k];
                        vert[i][j][0][2] = k;
                        continue;
                    }
                    if (dist[k] - j < vert[i][j][1][0] && k != vert[i][j][0][2] && dist[k] != vert[i][j][0][1]){
                        vert[i][j][1][0] = j - dist[k];
                        vert[i][j][1][1] = dist[k];
                        vert[i][j][1][2] = k;
                    }
                }
            }
            dist[int(s[j][i] - 'a')] = j;
        }
    }

    /*for (int i = 0; i < m; i++){
        for (int j = 0; j < n; j++)
            cout << gor[i][j][0][1] << " " << gor[i][j][1][1] << endl;
        cout << endl;
    }/**/

    int q;
    scanf("%d", &q);
    for (int k = 0; k < q; k++){
        int x, y;
        scanf("%d%d", &x, &y);
        x--;
        y--;
        int v1 = 0;
        int v2 = 1;
        int u1 = 0;
        int u2 = 1;
        if (gor[x][y][v1][2] != vert[y][x][u1][2] && gor[x][y][v1][0] != INF && vert[y][x][u1][0] != INF){
            printf("%d %d %d %d\n", x + 1, gor[x][y][v1][1] + 1, vert[y][x][u1][1] + 1, y + 1);
            continue;
        }
        if (gor[x][y][v1][0] + vert[y][x][u2][0] > gor[x][y][v2][0] + vert[y][x][u1][0])
            v1 = 1;
        else
            u1 = 1;
        if (gor[x][y][v1][2] != vert[y][x][u1][2] && gor[x][y][v1][0] != INF && vert[y][x][u1][0] != INF){
            printf("%d %d %d %d\n", x + 1, gor[x][y][v1][1] + 1, vert[y][x][u1][1] + 1, y + 1);
            continue;
        }
        printf("-1\n");
    }
    return 0;
}
