#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

const long long LINF = 3e18;


int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));

	vector<long long> nums;

	int t;
	cin >> t;
	for (int test = 0; test < t; test++)
	{
		long long n, a;
		cin >> a >> n;
		long long b = LINF;
		for (long long i = 62; i >= 0; i--)
		{

			long long mask = (a >> i);
			long long l = 0, r = LINF / n;
			while (r - l > 1)
			{
				long long m = (l + r) / 2;
				if (((n * m) >> i) <= mask)
				{
					l = m;
				}
				else
				{
					r = m;
				}
			}
			if (((n * l) >> i) == mask)
			{
				b = min(b, a ^ (n * l));
			}
		}

		cout << b << "\n";
	}
	
	return 0;
}