#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long n, m, k;

struct seg
{
	long long pos;
	long long type;
	long long id;

	bool operator< (seg s)
	{
		if (pos != s.pos)
			return pos < s.pos;
		if (type != s.type)
			return type < s.type;
		if (id != s.id)
			return id < s.id;
		return false;
	}

	seg(){};
	seg(long long p, long long t, long long i) : pos(p), type(t), id(i) {};
};

int fmain()
{
	cin >> n >> m >> k;
	vector<seg> ss;
	vector<long long> dur;
	for (long long i = 0; i < k; ++i)
	{
		long long a, b;
		cin >> a >> b;
		ss.push_back(seg(a, 1, i));
		ss.push_back(seg(b, 0, i));
		dur.push_back(b - a);
	}

	sort(ss.begin(), ss.end());

	long long n_sit = 1;

	vector<bool> st(m, false);
	vector<long long> ps(k, -1);

	vector<long long> total(m, 0);

	long long ls = 0;

	for (seg s : ss)
	{
		if (s.type == 0)
		{
			if (ps[s.id] == -1)
				n_sit--;
			else
			{
				st[ps[s.id]] = false;
				ps[s.id] = -1;
			}
		}

		if (s.type == 1)
		{
			if (n_sit >= m)
			{
				// TODO
				for (long long i = 0; i < m; ++i)
				{
					if (!st[i])
					{
						ps[s.id] = i;
						st[i] = true;
						total[i] += dur[s.id];
						break;
					}
				}
				if (ps[s.id] == -1)
					continue;
			}
			else
			{
				n_sit++;
			}
		}

		ls = s.pos;
	}

	auto ml = min_element(total.begin(), total.end());
	for (long long i = 0; i < m; ++i)
	{
		if (total[i] == *ml)
		{
			cout << *ml << " " << i + 1 << endl;
			return 0;
		}
	}

	return 0;
}

int main()
{
	fmain();
	return 0;
}