#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, k, m;

vector<int> d;

template <class It>
int solve(It begin, It end)
{
	if (end - begin <= 0)
		return n;
	int ans = n;
	int li = begin - d.begin();
	while (li < end - d.begin())
	{
		int v = d[li];
		auto ub = lower_bound(begin, end, v + k);
		ans -= k;
		int nn = ub - d.begin();
		li = nn;
	}
	return max(0, ans);
}

int fmain()
{
	cin >> n >> k >> m;

	for (int i = 0; i < m; ++i)
	{
		int t;
		cin >> t;
		d.push_back(t);
	}
	sort(d.begin(), d.end());
	vector<int> a;
	a.push_back(solve(d.begin(), d.end()));
	auto q = upper_bound(d.begin(), d.end(), k - 1);
	auto w = lower_bound(d.begin(), d.end(), n - k + 1);

	if (q > d.begin())
		a.push_back(solve(q, d.end()) - *(q - 1));
	if (w < d.end())
		a.push_back(solve(d.begin(), w) - (n - *w + 1));
	if ((q > d.begin()) && (w < d.end()))
		a.push_back(solve(q, w) - (n - *w + 1) - *(q - 1));

	cout << *max_element(a.begin(), a.end()) << endl;

	return 0;
}

int main()
{
	fmain();
	return 0;
}