#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
//#define int int64_t

struct hap {
    int time, type, id;
    hap(int time, int type, int id) {
        this -> time = time;
        this -> type = type;
        this -> id = id;
    }
};

bool cmp(hap a, hap b) {
    if (a.time != b.time)
        return a.time < b.time;
    else
        return a.type < b.type;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    vector<hap> haps;
    vector<pair<int, int> > segments(k);
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        segments[i] = {a, b};
        haps.push_back(hap(a, 1, i));
        haps.push_back(hap(b, -1, i));
    }

    sort(haps.begin(), haps.end(), cmp);


    set<int> empty_sits, empty_stands;
    for (int i = 0; i < m; i++)
        empty_stands.insert(i);
    for (int i = 0; i < m - 1; i++)
        empty_sits.insert(i);

    vector<pair<int, bool> > place(k, {-1, false}); //first is place, second is IS_SITTING
    vector<pair<int, int> > res_segments;

    for (auto hap : haps) {
        //cout << hap.time << " " << hap.type << " " << hap.id << endl;
        if (hap.type == 1) {
            if (!empty_sits.empty()) {
                int cur = *empty_sits.begin();
                empty_sits.erase(empty_sits.begin());
                place[hap.id] = {cur, true};
            }
            else if (!empty_stands.empty()) {
                int cur = *empty_stands.begin();
                empty_stands.erase(empty_stands.begin());
                if (cur == m - 1)
                    res_segments.push_back(segments[hap.id]);
                place[hap.id] = {cur, false};
            }
        }
        else if (place[hap.id].first != -1) {
            if (place[hap.id].second) //if sit
                empty_sits.insert(place[hap.id].first);
            else
                empty_stands.insert(place[hap.id].first);
        }
    }

    int ans = 0;
    for (auto x : res_segments) {
        ans += x.second - x.first;
    }

    cout << ans << " " << m;

    return 0;
}
