#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back
#define F first
#define S second

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int sN = 1000000;

int lp[sN];
vector <int> pr;
ll x, n;
vector <ll> z;
bool f = false;

int calc(int x) {
    ll d = 2;
    int res = 1;
    while (d * d < x) {
        if (x % d == 0)
            res += 2;
        d++;
    }
    if (d * d == x)
        res++;
    return res;
}

void dfs(int v, ll cur, int cnt) {
    if (f)
        return;
    if (cur > n)
        return;
    if (cnt == 7) {
        if (cur >= x && cur <= n) {
            cout << cur << endl;
            f = true;
            return;
        }
        ll add = cur / n;
        if (cur * add >= x && cur * add <= n) {
            cout << cur * add << endl;
            f = true;
        }
        return;
    }
    if (v == z.size())
        return;
    dfs(v + 1, cur, cnt);
    cur *= z[v];
    dfs(v + 1, cur, cnt + 1);
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> x;
    ld c = 1.01 * x;
    n = ll(c);
    if (n < 1021020) {
        for (int i = x; i <= n; i++) {
            if (calc(i) >= 100) {
                cout << i << endl;
                return 0;
            }
        }
        cout << -1 << endl;
        return 0;
    }
    for (int i = 2; i < sN; i++) {
        if (!lp[i]) {
            lp[i] = i;
            pr.pb(i);
        }
        for (int j = 0; j < pr.size() && pr[j] <= lp[i] && 1ll * i * pr[j] < sN; j++)
            lp[i * pr[j]] = pr[j];
    }
    for (int i = 0; i < 70; i++)
        z.pb(pr[i]);
    //cout << z.back() << endl;
    ll m = 1;
//    for (int i = 42; i < 50; i++)
//        m *= pr[i];
//    cout << m << endl;
//    for (int i = 0; i < z.size(); i++)
//        cout << z[i] << ' ';
//    cout << endl;
    dfs(0, 1, 0);
    if (!f)
        cout << -1 << endl;
    return 0;
}
