#include <set>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;



int main()
{
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m, k;
    cin >> n >> m >> k;
    vector <pair <pair <int, int>, int> > L(2 * k);
    vector <pair<pair <int, int> , int> > A(k);
    for (int i = 0; i < k; ++i)
    {
        int a, b;
        cin >> a >> b;
        L[2 * i] = {{a, 0}, i};
        L[2 * i + 1] = {{b, 1}, i};
        A[i] = {{a, b}, -1};
    }

    sort(L.begin(), L.end());
    vector <int> T(m);
    int seat = m - 1;
    set <int> S;
    for (int i = 0; i < m; ++i)
    {
        S.insert(i);
    }
    for (int i = 0; i < L.size(); ++i)
    {
        if (L[i].first.second == 0)
        {
            if (seat > 0)
            {
                --seat;
            }
            else if (S.size() > 0)
            {
                A[L[i].second].second = *S.begin();
                S.erase(S.begin());
            }
        }
        else
        {
            if (A[L[i].second].second == -1)
            {
                ++seat;
            }
            else
            {
                S.insert(A[L[i].second].second);
                T[A[L[i].second].second] += A[L[i].second].first.second - A[L[i].second].first.first;
            }
        }
    }
    int a = min_element(T.begin(), T.end()) - T.begin();
    cout << T[a] << " " << a + 1 << endl;
    return 0;
}
