import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by orspc on 11.12.2016.
 */
public class Main {
    public void solve() throws IOException{
        int x = nextInt(), y = nextInt(), z = nextInt();
        int sum = x + y + z;
        sum /= 2;
        if(x + y == sum || x + z == sum || y + z == sum) out.print(0);
        else{
            int k = Math.max(x, y);
            if(x + y < sum){
                out.println(3);
                out.print(sum + " " + (z - sum));

            }else{
                if(x > y) out.println(1);
                else out.println(2);
                out.print((sum - Math.min(x, y)) + " " + (x + y - sum));
            }
        }
    }
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;
    public long nextLong() throws IOException{
        return Long.parseLong(nextToken());
    }
    public double nextDouble() throws IOException{
        return Double.parseDouble(nextToken());
    }
    public int nextInt() throws IOException{
        return Integer.parseInt(nextToken());
    }
    public String nextToken() throws IOException{
        while(sc == null || !sc.hasMoreTokens()){
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (IOException e){
                return null;
            }
        }
        return sc.nextToken();
    }
    public void run() throws  IOException{
        try{
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e){
            e.printStackTrace();
            System.exit(1);
        }
    }
    public static void main(String[] args)  throws IOException{
        Locale.setDefault(Locale.US);
        new Main().run();
    }
}
