#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)5e5 + 7;

ll S[dd];
int Y[dd], H[dd];

struct Q {
	int t, typ, ind, L;
};

int solve() {
	set<int> A, B;
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);

	for (int i = 0; i < m - 1; ++i) {
		A.insert(i);
	}
	for (int i = 0; i < m; ++i) {
		B.insert(i);
	}
	int x, y;
	vector <Q> D;
	for (int i = 0; i < k; ++i) {
		scanf("%d %d", &x, &y);
		D.push_back({ x, 1, i, y });
		D.push_back({ y, -1, i, x });
	}

	sort(D.begin(), D.end(), [](Q a, Q b) {
		return a.t == b.t ? a.typ < b.typ : a.t < b.t;
	});

	for (auto i : D) {
		if (i.typ == -1) {
			if (H[i.ind] == 1) {
				S[Y[i.ind]] += i.t - i.L;
				B.insert(Y[i.ind]);
			} else if (H[i.ind] == 0) {
				A.insert(Y[i.ind]);
			}
		} else {
			if ((int)A.size()) {
				int it = *A.begin();

				A.erase(A.begin());

				H[i.ind] = 0;
				Y[i.ind] = it;

			} else {
				if ((int)B.size()) {
					int it = *B.begin();
					B.erase(B.begin());
					H[i.ind] = 1;
					Y[i.ind] = it;
				} else {
					H[i.ind] = 2;
					continue;
				}
			}
		}
	}

	int ans = 0;
	for (int i = 1; i < m; ++i)
		if (S[ans] > S[i])
			ans = i;

	cout << S[ans] << " " << ans + 1;

	return 0;
}