#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)4e5 + 7;

int d[dd];
int P[dd], S[dd];

int solve() {

	int n, k, m;
	scanf("%d %d %d", &n, &k, &m);

	for (int i = 0; i < m; i++) {
		scanf("%d", &d[i]);
	}

	sort(d, d + m);

	fill(P, P + dd, 0);
	fill(S, S + dd, 0);

	for (int i = 0; i < m; i++) {
		int ind = upper_bound(d, d + m, d[i] - k) - d;

		if (ind == 0) {
			P[i] = max(d[i] - k, 0);
		} else {
			P[i] = P[ind - 1] + (d[i] - k) - d[ind - 1];
		}
	}

	for (int i = m - 1; i >= 0; i--) {
		int ind = lower_bound(d, d + m, d[i] + k) - d - 1;

		if (ind == m - 1) {
			S[i] = max(0, n - (d[i] + k - 1));
		} else {
			S[i] = S[ind + 1] + d[ind + 1] - (d[i] + k);
		}
	}
	
	int ans = max(S[0] + d[0] - 1, P[m - 1] + n - d[m - 1]);

	for (int i = 1; i < m; i++) {
		ans = max(ans, P[i - 1] + S[i] + d[i] - d[i - 1] - 1);
	}

	printf("%d\n", ans);

	return 0;
}