#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
using namespace std;

#define int long long

struct ev {
    int type, id, time;

    ev (int a = 0, int b = 0, int c = 0) {
        type = a;
        id = b;
        time = c;
    }
};

bool cmp(ev A, ev B) {
    if (A.time == B.time) {
        return (A.type < B.type);
    } else {
        return A.time < B.time;
    }
}


signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector <ev> events;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        events.push_back(ev(1, i, x));
        events.push_back(ev(-1, i, y));
    }
    sort(events.begin(),events.end(), cmp);
    set <int> free_place;
    set <int> free_soul;
    for (int i = 1; i < m; i++) {
        free_place.insert(i);
    }
    vector <pair <int, int> > place(k);
    for (int i = 1; i <= m; i++) {
        free_soul.insert(i);
    }

    vector <int> answ(m, 0);
    for (auto eve : events) {
        if (eve.type == -1) {
            int id = eve.id;
            if (place[id].first == 1) {
                free_place.insert(place[id].second);
            } else {
                free_soul.insert(place[id].second);
                answ[place[id].second - 1] += eve.time;
            }
        } else {
            int id = eve.id;
            int x = eve.time;
            if (free_place.empty()) {
                int new_sit = *free_soul.begin();
                free_soul.erase(new_sit);
                place[id] = make_pair(-1, new_sit);
                answ[new_sit - 1] -= x;
            } else {
                int new_sit = *free_place.begin();
                free_place.erase(new_sit);
                place[id] = make_pair(1, new_sit);
            }
        }
    }
    int ans_ind = 0;
    for (int i = 0; i < m; i++) {
        if (answ[ans_ind] > answ[i]) {
            ans_ind = i;
        }
    }
    cout << answ[ans_ind] << " " << ans_ind + 1;

    return 0;
}
