import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Z {
    String fileName = "<name>";

    public void solve() throws IOException {
    	int ALPH = 26;
    	int INF = Integer.MAX_VALUE;
    	int n = nextInt(), m = nextInt();
    	int[][] a = new int[n][m];
    	for (int i = 0; i < n; i++) {
			String s = nextToken();
			for (int j = 0; j < m; j++) {
				a[i][j] = (int) (s.charAt(j) - 'a');
			}
		}
    	
    	@SuppressWarnings("unchecked")
		ArrayList<Integer>[][] s = new ArrayList[n][ALPH];
    	for (int i = 0; i < n; i++) {
			for (int j = 0; j < ALPH; j++) {
				s[i][j] = new ArrayList<>();
			}
		}
    	for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				s[i][a[i][j]].add(j);
			}
		}
    	
    	@SuppressWarnings("unchecked")
		ArrayList<Integer>[][] c = new ArrayList[m][ALPH];
    	for (int i = 0; i < m; i++) {
			for (int j = 0; j < ALPH; j++) {
				c[i][j] = new ArrayList<>();
			}
		}
    	for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				c[j][a[i][j]].add(i);
			}
		}
    	
    	
    	int q = nextInt();
    	for (int i = 0; i < q; i++) {
			int x = nextInt() - 1, y = nextInt() - 1;
			int min = INF;
			int x1 = -1, y1 = -1;
			for (int iii = 0; iii < ALPH; iii++) {
				for (int jjj = 0; jjj < ALPH; jjj++) {
					if (iii == jjj) {
						continue;
					}
//					Integer l = s[x][iii].lower(y);
//					Integer r = s[x][iii].higher(y);
//					Integer u = c[y][jjj].lower(x);
//					Integer d = c[y][jjj].higher(x);
					int ll = -1, rr = s[x][iii].size();
					while (ll != rr - 1) {
						int mm = (ll + rr) / 2;
						if (s[x][iii].get(mm) < y) {
							ll = mm;
						} else {
							rr = mm;
						}
					}
					Integer l = ((ll == -1) ? null : s[x][iii].get(ll));
					
					ll = -1;
					rr = s[x][iii].size();
					while (ll != rr - 1) {
						int mm = (ll + rr) / 2;
						if (s[x][iii].get(mm) <= y) {
							ll = mm;
						} else {
							rr = mm;
						}
					}
					Integer r = ((rr == s[x][iii].size()) ? null : s[x][iii].get(rr));
					
					ll =-1; rr = c[y][jjj].size();
					while (ll != rr - 1) {
						int mm = (ll + rr) / 2;
						if (c[y][jjj].get(mm) < y) {
							ll = mm;
						} else {
							rr = mm;
						}
					}
					Integer u = ((ll == -1) ? null : c[y][jjj].get(ll));
					
					ll = -1;
					rr = c[y][jjj].size();
					while (ll != rr - 1) {
						int mm = (ll + rr) / 2;
						if (c[y][jjj].get(mm) <= y) {
							ll = mm;
						} else {
							rr = mm;
						}
					}
					Integer d = ((rr == c[y][jjj].size()) ? null : c[y][jjj].get(rr));
					
					int ans = -1;
					if (u != null && r != null) {
						int res = Math.abs(y - r) + Math.abs(x - u);
						if (res < min) {
							min = res;
							y1 = r;
							x1 = u;
						}
					}
					if (d != null && r != null) {
						int res = Math.abs(y - r) + Math.abs(x - d);
						if (res < min) {
							min = res;
							y1 = r;
							x1 = d;
						}
					}
					if (d != null && l != null) {
						int res = Math.abs(y - l) + Math.abs(x - d);
						if (res < min) {
							min = res;
							y1 = l;
							x1 = d;
						}
					}
					if (u != null && l != null) {
						int res = Math.abs(y - l) + Math.abs(x - u);
						if (res < min) {
							min = res;
							y1 = l;
							x1 = u;
						}
					}
				}
			}
			if (x1 == -1) {
				System.out.println(-1);
			} else {
				System.out.println((x + 1) + " " + (y1 + 1) + " " + (x1 + 1) + " " + (y + 1));
			}
		}
    	
    	
    	
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

//            br = new BufferedReader(new FileReader(new File("input.txt"))); 
//            out = new PrintWriter(System.out);
            
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    @Override
	public String toString() {
		return "A [fileName=" + fileName + ", br=" + br + ", in=" + in + ", out=" + out + "]";
	}

	BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Z().run();
    }

}
