import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class Z {
    String fileName = "<name>";

    public class Pair implements Comparable<Pair> {
    	int x;
    	int t;
    	int i;
		public Pair(int x, int y, int i) {
			this.x = x;
			this.t = y;
			this.i = i;
		}
		@Override
		public int compareTo(Pair o) {
			if (this.x != o.x) {
				return this.x - o.x;
			}
			if (this.t != o.t) {
				return -(this.t - o.t);
			}
			return this.i - o.i;
		}
		@Override
		public String toString() {
			return "Pair [x=" + x + ", t=" + t + ", i=" + i + "]";
		}

		
		
    }
    
    public void solve() throws IOException {
    	int t = nextInt();
    	for (int i = 0; i < t; i++) {
			BigInteger a, b, n;
			a = BigInteger.valueOf(nextLong());
			n = BigInteger.valueOf(nextLong());
			
			BigInteger x = a.divide(n);
			BigInteger tau = BigInteger.valueOf(100);
			BigInteger one = BigInteger.valueOf(1);
			BigInteger noll = BigInteger.valueOf(0);
			b = BigInteger.valueOf((long) 10e18);
			b = b.multiply(b);
			for (BigInteger j = x; j.compareTo(x.add(tau)) < 0; j = j.add(one)) {
				b = b.min(n.multiply(j).xor(a));
			}
			for (BigInteger j = x; j.compareTo(x.subtract(tau).max(noll)) > 0; j = j.subtract(one)) {
				b = b.min(n.multiply(j).xor(a));
			}
			System.out.println(b);
		}
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

//            br = new BufferedReader(new FileReader(new File("input.txt"))); 
//            out = new PrintWriter(System.out);
            
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    @Override
	public String toString() {
		return "A [fileName=" + fileName + ", br=" + br + ", in=" + in + ", out=" + out + "]";
	}

	BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Z().run();
    }

}
