#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
using namespace std;

const int S = 1000000 + 228;
int x, y;
char s[S];
int l[26][S], r[26][S], u[26][S], d[26][S];

int nw[26];

int get_(int i, int j){
	return i * y + j;
}

bool f(int re, int rw)
{
	if (re != -1 && rw != -1 && re != rw)
		return true;
	return false;
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &x, &y);
	for (int i = 0; i < x; i++)
		for (int j = 0; j < y; j++){
			scanf(" %c", &s[get_(i, j)]);
		}
	for (int i = 0; i < x; i++){
		for (int j = 0; j < 26; j++)
			nw[j] = -1;
		for (int j = 0; j < y; j++){
			for (int k = 0; k < 26; k++){
				if (nw[k] != -1)
					l[k][i * y + j] = j - nw[k];
				else
					l[k][i * y + j] = -1;
			}
			nw[s[get_(i, j)] - 'a'] = j;
		}
		for (int j = 0; j < 26; j++)
			nw[j] = -1;
		for (int j = y - 1; j >= 0; j--){
			for (int k = 0; k < 26; k++){
				if (nw[k] != -1)
					r[k][i * y + j] = nw[k] - j;
				else
					r[k][i * y + j] = -1;
			}
			nw[s[get_(i, j)] - 'a'] = j;
		}
	}
	for (int j = 0; j < y; j++){
		for (int k = 0; k < 26; k++)
			nw[k] = -1;
		for (int i = 0; i < x; i++){
			for (int k = 0; k < 26; k++){
				if (nw[k] != -1)
					u[k][i * y + j] = i - nw[k];
				else
					u[k][i * y + j] = -1;
			}
			nw[s[get_(i, j)] - 'a'] = i;
		}
		for (int k = 0; k < 26; k++)
			nw[k] = -1;
		for (int i = x - 1; i >= 0; i--){
			for (int k = 0; k < 26; k++){
				if (nw[k] != -1)
					d[k][i * y + j] = nw[k] - i;
				else
					d[k][i * y + j] = -1;
			}
			nw[s[get_(i, j)] - 'a'] = i;
		}
	}
	int q;
	cin >> q;
	int a, b;
	for (int t = 0; t < q; t++){
		scanf("%d%d", &a, &b);
		--a;
		--b;
		int w = get_(a, b), aa1 = 10000000, aa2 = 10000000, a1 = -1, a2 = -1, b1 = -1, b2 = -1, bb1 = 10000000, bb2 = 10000000;
		int ia11 = -1, ia12 = -1, ia21 = -1, ia22 = -1, ib11 = -1, ib12 = -1, ib21 = -1, ib22 = -1;
		for (int i = 0; i < 26; i++)
		{
			bool f = false;
			int ar1 = l[i][w], ar2 = r[i][w], arr;
			if (ar1 == -1 && ar2 == -1)
				continue;
			else if (ar1 == -1)
			{
				arr = ar2;
				f = false;
			}
			else if (ar2 == -1)
			{
				arr = ar1;
				f = true;
			}
			else
			{
				if (ar1 < ar2)
				{
					arr = ar1;
					f = true;
				}
				else
				{
					arr = ar2;
					f = false;
				}
			}
			if (aa1 > arr)
			{
				aa2 = aa1;
				a2 = a1;
				ia21 = ia11;
				ia22 = ia12;
				aa1 = arr;
				a1 = i;
				if (f)
				{
					ia11 = a;
					ia12 = b - arr;
				}
				else
				{
					ia11 = a;
					ia12 = b + arr;
				}
			}
			else if (aa2 > arr)
			{
				aa2 = arr;
				a2 = i;
				if (f)
				{
					ia21 = a;
					ia22 = b - arr;
				}
				else
				{
					ia21 = a;
					ia22 = b + arr;
				}
			}
		}
		for (int i = 0; i < 26; i++)
		{
			bool f = false;
			int ar1 = u[i][w], ar2 = d[i][w], arr;
			if (ar1 == -1 && ar2 == -1)
				continue;
			else if (ar1 == -1)
			{
				arr = ar2;
				f = false;
			}
			else if (ar2 == -1)
			{
				arr = ar1;
				f = true;
			}
			else
			{
				if (ar1 < ar2)
				{
					arr = ar1;
					f = true;
				}
				else
				{
					arr = ar2;
					f = false;
				}
			}
			if (bb1 > arr)
			{
				bb2 = bb1;
				b2 = b1;
				ib21 = ib11;
				ib22 = ib12;
				bb1 = arr;
				b1 = i;
				if (f)
				{
					ib11 = a - arr;
					ib12 = b;
				}
				else
				{
					ib11 = a + arr;
					ib12 = b;
				}
			}
			else if (bb2 > arr)
			{
				bb2 = arr;
				b2 = i;
				if (f)
				{
					ib21 = a - arr;
					ib22 = b;
				}
				else
				{
					ib21 = a + arr;
					ib22 = b;
				}
			}
		}
		int as = 10000000, ina1, ina2, inb1, inb2;
		if (f(a1, b1))
		{
			if (as > aa1 + bb1)
			{
				as = aa1 + bb1;
				ina1 = ia11;
				ina2 = ia12;
				inb1 = ib11;
				inb2 = ib12;
			}
		}
		if (f(a2, b1))
		{
			if (as > aa2 + bb1)
			{
				as = aa2 + bb1;
				ina1 = ia21;
				ina2 = ia22;
				inb1 = ib11;
				inb2 = ib12;
			}
		}
		if (f(a1, b2))
		{
			if (as > aa1 + bb2)
			{
				as = aa1 + bb2;
				ina1 = ia11;
				ina2 = ia12;
				inb1 = ib21;
				inb2 = ib22;
			}
		}
		if (f(a2, b2))
		{
			if (as > aa2 + bb2)
			{
				as = aa2 + bb2;
				ina1 = ia21;
				ina2 = ia22;
				inb1 = ib21;
				inb2 = ib22;
			}
		}
		if (as == 10000000)
			printf("%d\n", -1);
		else
		{
			printf("%d %d %d %d\n", ina1 + 1, ina2 + 1, inb1 + 1, inb2 + 1);
		}
	}
}
