#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <stdio.h>
#include <list>
#include <math.h>
#include <time.h>
#include <queue>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const ll SZ = 5e5 + 10;
const ll INF = 1e9;

//bool l[SZ][SZ], e[SZ][SZ];
//ll xold[SZ][SZ], xnew[SZ][SZ];
string st[SZ];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
#endif

	/*ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < n; i++) {
	ll x;
	cin >> x;
	while (x--) {
	ll d;
	cin >> d;
	d--;
	l[i][d] = true;
	}
	}
	for (ll i = 0; i < n; i++)
	for (ll j = 0; j < n; j++) {
	bool mt = false;
	for (ll k = 0; k < m; k++)
	if (l[i][k] && l[j][k])
	mt = true;
	if (mt)
	e[i][j] = true;
	}

	for (ll i = 0; i < n; i++)
	for (ll j = 0; j < n; j++)
	if (i == j)
	xold[i][j] = 0;
	else if (e[i][j])
	xold[i][j] = 1;
	else
	xold[i][j] = INF;

	for (ll i = 0; i < n; i++) {
	for (ll j = 0; j < n; j++)
	for (ll k = 0; k < n; k++)
	xnew[j][k] = min(xold[j][k], xold[j][i] + xold[i][k]);
	for (ll j = 0; j < n; j++)
	for (ll k = 0; k < n; k++)
	xold[j][k] = xnew[j][k];
	}

	for (ll i = 0; i < n; i++) {
	for (ll j = 0; j < n; j++)
	cout << (xold[i][j] == INF ? -1 : xold[i][j]) << " ";
	cout << "\n";
	}*/

	int n, m;
	cin >> n >> m;
	vector<vector<char>> st(n, vector<char>(m));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			cin >> st[i][j];

	vector<vector<vector<int>>> q(n, vector<vector<int>>(m));

	int qq;
	cin >> qq;
	for (int i = 0; i < qq; i++) {
		int a, b;
		scanf("%d%d", &a, &b);
		a--; b--;
		q[a][b].push_back(i);
	}

	vector<vector<vector<int>>> hors(26, vector<vector<int>>(n));
	vector<vector<vector<int>>> vers(26, vector<vector<int>>(m));
	vector<vector<int>> horp(26, vector<int>(n, -INF));
	vector<vector<int>> verp(26, vector<int>(m, -INF));

	for (int i = 0; i < 26; i++)
		for (int j = 0; j < n; j++)
			hors[i][j].reserve(m / 10);
	for (int i = 0; i < 26; i++)
		for (int j = 0; j < m; j++)
			vers[i][j].reserve(n / 10);

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			hors[st[i][j] - 'a'][i].push_back(j);
	for (int j = 0; j < m; j++)
		for (int i = 0; i < n; i++)
			vers[st[i][j] - 'a'][j].push_back(i);

	for (int i = 0; i < 26; i++)
		for (int j = 0; j < n; j++)
			reverse(hors[i][j].begin(), hors[i][j].end());
	for (int i = 0; i < 26; i++)
		for (int j = 0; j < m; j++)
			reverse(vers[i][j].begin(), vers[i][j].end());

	vector<pair<int, pair<pair<int, int>, pair<int, int>>>> ans;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++)
			vers[st[i][j] - 'a'][j].pop_back();
		for (int j = 0; j < m; j++) {
		hors[st[i][j] - 'a'][i].pop_back();
		int mn = INF, cx, cy, dx, dy;
		cx = cy = dx = dy = -1;
		if (i) { // up
			for (int k = 0; k < 26; k++)
				if (k != st[i - 1][j] - 'a') {
				if (hors[k][i].size())
					if (abs(hors[k][i].back() - j) + 1 < mn) {
					mn = abs(hors[k][i].back() - j) + 1;
					cx = i - 1;
					cy = j;
					dx = i;
					dy = hors[k][i].back();
					}
				int e = horp[k][i];
				if (abs(e - j) + 1 < mn) {
					mn = abs(e - j) + 1;
					cx = i - 1;
					cy = j;
					dx = i;
					dy = e;
				}
				}
		}

		if (i != n - 1) { // down
			for (int k = 0; k < 26; k++)
				if (k != st[i + 1][j] - 'a') {
				if (hors[k][i].size())
					if (abs(hors[k][i].back() - j) + 1 < mn) {
					mn = abs(hors[k][i].back() - j) + 1;
					cx = i + 1;
					cy = j;
					dx = i;
					dy = hors[k][i].back();
					}
				int e = horp[k][i];
				if (abs(e - j) + 1 < mn) {
					mn = abs(e - j) + 1;
					cx = i + 1;
					cy = j;
					dx = i;
					dy = e;
				}
				}
		}

		if (j) { // left
			for (int k = 0; k < 26; k++)
				if (k != st[i][j - 1] - 'a') {
				if (vers[k][j].size())
					if (abs(vers[k][j].back() - i) + 1 < mn) {
					mn = abs(vers[k][j].back() - i) + 1;
					cx = i;
					cy = j - 1;
					dx = vers[k][j].back();
					dy = j;
					}
				int e = verp[k][j];
				if (abs(e - i) + 1 < mn) {
					mn = abs(e - i) + 1;
					cx = i;
					cy = j - 1;
					dx = verp[k][j];
					dy = j;
				}
				}
		}

		if (j != m - 1) { // right
			for (int k = 0; k < 26; k++)
				if (k != st[i][j + 1] - 'a') {
				if (vers[k][j].size())
					if (abs(vers[k][j].back() - i) + 1 < mn) {
					mn = abs(vers[k][j].back() - i) + 1;
					cx = i;
					cy = j + 1;
					dx = vers[k][j].back();
					dy = j;
					}
				int e = verp[k][j];
				if (abs(e - i) + 1 < mn) {
					mn = abs(e - i) + 1;
					cx = i;
					cy = j + 1;
					dx = verp[k][j];
					dy = j;
				}
				}
		}

		for (int k : q[i][j])
			ans.push_back({ k, { { cx, cy }, { dx, dy } } });
		horp[st[i][j] - 'a'][i] = j;

		}
		for (int j = 0; j < m; j++)
			verp[st[i][j] - 'a'][j] = i;
	}

	sort(ans.begin(), ans.end());
	for (auto i : ans) {
		if (i.second.first.first == -1)
			printf("-1\n");
		else
			printf("%d %d %d %d\n", i.second.first.first + 1, i.second.first.second + 1, i.second.second.first + 1, i.second.second.second + 1);
	}

	return 0;
}