#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

const double EPS = 1e-9;
typedef long long ll;
const int sz = 5e2;
const int INF = 1e9;

int main() {
#ifdef MINE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, k, m;
	cin >> n >> k >> m;
	set<int> days = { n + 1, INF };
	for (size_t i = 0; i < m; i++)
	{
		int day;
		cin >> day;
		days.insert(day);
	}

	int res1 = 0;
	bool gone = false;
	int curr_day = 0;
	while (curr_day <= n) {
		int next_day;
		if (gone) {
			next_day = curr_day + k - 1;
		}
		else {
			next_day = *days.upper_bound(curr_day);
			res1 += next_day - curr_day - 1;
		}
		gone = !gone;
		curr_day = next_day;
	}

	days.insert(*days.begin() - k + 1);
	gone = false;
	curr_day = min(0, *days.begin() - 1);
	//int res = max(0, curr_day - k + 1);
	int res = 0;
	while (curr_day <= n) {
		int next_day;
		if (gone) {
			next_day = curr_day + k - 1;
		}
		else {
			next_day = *days.upper_bound(curr_day);
			res += next_day - curr_day - 1;
		}
		gone = !gone;
		//cout << next_day << " " << res << " " << gone << "\n";
		curr_day = next_day;
	}



	cout << max(res, res1);

	return 0;
}