#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


long long bs(vector<long long>& d, int s, long long dist) {
    long long left = 0, right = s - 1, middle;
    long long ds = d[s] - dist;
    while (left < right) {
        middle = (left + right) / 2 + 1;
        if (d[middle] <= ds)
            left = middle;
        else
            right = middle - 1;
    }
    return left;
}

int main() {
    long long n, k, m, dk, d2k;
    cin >> n >> k >> m;
    vector<long long> p1(m, 0), p2(m, 0), d(m);
    for (int i = 0; i < m; i++)
        cin >> d[i];
    sort(d.begin(), d.end());
    p1[0] = min(k, d[0]);
    p2[0] = min(k, n - d[0] + 1);

    for (int i = 1; i < m; i++) {
        if (d[i] - d[0] < k)
            dk = -1;
        else
            dk = bs(d, i, k);
        if (d[i] - d[0] < 2 * k - 1)
            d2k = -1;
        else
            d2k = bs(d, i, 2 * k - 1);
        p1[i] = min(k, d[i]);
        if (d2k >= 0)
            p1[i] += min(p1[dk], p2[d2k]);
        else if (dk >= 0)
            p1[i] += p1[dk];

        p2[i] = min(k, n - d[i] + 1);
        if (dk >= 0)
            p2[i] += min(p1[i - 1], p2[dk]);
        else
            p2[i] += p1[i - 1];
    }
    long long ans = p1[m - 1];
    int i = m - 1;
    while (i >= 0 && d[m - 1] - d[i] + 1 <= k) {
        ans = min(ans, p2[i]);
        --i;
    }
    cout << n - ans << endl;
    return 0;
}
