#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
const int INF = (int)1e9 + 7;
const int MAXN = 500003;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	solve();
	return 0;
}
int n, k, m;
vector <int> a;
int ub(int y)
{
	int l = 0, r = m + 1;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		if (a[m] < y + 0.5)
			l = m;
		else r = m;
	}
		return r;
}
int ub1(int y)
{
	int l = 0, r = m + 1;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		if (a[m] < y )
		l = m;
		else r = m;
	}
	return r;
}
int lb1(int y)
{
	int l = 0, r = m + 1;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		if (a[m] <= y)
			l = m;
		else r = m;
	}
	return l;
}

int count(int x, int y)
{
	int y1 = lb1(y),x1=ub1(x);
	return (y - x - max((y1 - x1),0));

}

int solve() {
	//freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	cin >> n >> k >> m;
	a.push_back(0);
	for (int i = 1; i <= m; i++)
	{
		int c;
		scanf("%d", &c);
		a.push_back(c);
	}
	sort(a.begin(),a.end());
	int x=0;
	int ans = 0;
	for (int i = 1; i <= m; i++)
	{
		if (a[i] > k)
		{
			x = i;
			break;
		}
		if (count(1, a[i]) < count(a[i], a[i] + k - 1))
		{
			ans += a[i] - a[i - 1] - 1;
		}
		else {
			x = i;
			break;
		}

	}
	if (x == 0) cout << n - ans - m,exit(0);
	while (1)
	{
		int y = min(n, a[x] + k - 1);
		ans += count(a[x], y);
		x = ub(y);
		if (x == m + 1)
			break;

	}
	cout << n - ans - m, exit(0);

	return 0;
}


