#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int napr = 4;
const int two = 2;
const int alf = 26;
const int BIG = 1e9;

int n, m;
vector<string> s;
vector<vector<int> > dp[napr][alf];

void init_napr()
{
    for (int x = 0; x < 4; x++)
        for (int i = 0; i < alf; i++)
        {
            dp[x][i].resize(n);
            for (int j = 0; j < n; j++)
                dp[x][i][j].resize(m);
        }
    for (char c = 'a'; c <= 'z'; c++)
    {
        int p = c - 'a';
        //1
        for (int j = 0; j < m; j++)
        {
            dp[0][p][0][j] = BIG;
            for (int i = 1; i < n; i++)
            {
                if (s[i - 1][j] == c)
                {
                    dp[0][p][i][j] = 1;
                    continue;
                }
                dp[0][p][i][j] = dp[0][p][i - 1][j] + 1;
            }
        }
        //2
        for (int i = 0; i < n; i++)
        {
            dp[1][p][i][m - 1] = BIG;
            for (int j = m - 2; j >= 0; j--)
            {
                if (s[i][j + 1] == c)
                {
                    dp[1][p][i][j] = 1;
                    continue;
                }
                dp[1][p][i][j] = dp[1][p][i][j + 1] + 1;
            }
        }
        //3
        for (int j = 0; j < m; j++)
        {
            dp[2][p][n - 1][j] = BIG;
            for (int i = n - 2; i >= 0; i--)
            {
                if (s[i + 1][j] == c)
                {
                    dp[2][p][i][j] = 1;
                    continue;
                }
                dp[2][p][i][j] = dp[2][p][i + 1][j] + 1;
            }
        }
        //4
        for (int i = 0; i < n; i++)
        {
            dp[3][p][i][0] = BIG;
            for (int j = 1; j < m; j++)
            {
                if (s[i][j - 1] == c)
                {
                    dp[3][p][i][j] = 1;
                    continue;
                }
                dp[3][p][i][j] = dp[3][p][i][j - 1] + 1;
            }
        }
        /*cerr << c << endl;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
                cerr << dp[3][p][i][j] << " ";
            cerr << endl;
        }*/
    }
}

vector<vector<pair<int, int> > > go[two][alf];

void init_two()
{
    for (int i = 0; i < two; i++)
        for (int c = 0; c < alf; c++)
        {
            go[i][c].resize(n);
            for (int j = 0; j < n; j++)
                go[i][c][j].resize(m);
        }
    for (int p = 0; p < alf; p++)
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
            {
                int gor = min(dp[1][p][i][j], dp[3][p][i][j]);
                int vert = min(dp[0][p][i][j], dp[2][p][i][j]);
                if (gor < BIG)
                {
                    if (gor == dp[1][p][i][j])
                        go[0][p][i][j] = make_pair(gor, 1);
                    else
                        go[0][p][i][j] = make_pair(gor, 3);
                }
                else
                    go[0][p][i][j] = make_pair(BIG, 1);
                if (vert < BIG)
                {
                    if (vert == dp[0][p][i][j])
                        go[1][p][i][j] = make_pair(vert, 0);
                    else
                        go[1][p][i][j] = make_pair(vert, 2);
                }
                else
                    go[1][p][i][j] = make_pair(BIG, 0);
            }
    /*cerr << "kek" << endl;
    for (int p = 0; p < alf; p++)
    {
        cerr << (char)(p + 'a') << endl;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
                cerr << go[0][p][i][j].first << " ";
            cerr << endl;
        }
    }*/
}

vector<vector<pair<int, int> > > f[alf];

void init_mn()
{
    for (int c = 0; c < alf; c++)
    {
        f[c].resize(n);
        for (int j = 0; j < n; j++)
            f[c][j].resize(m);
    }
    vector<pair<int, int> > mn, mx;
    mx.resize(alf);
    mn.resize(alf);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
        {
            mn[0] = make_pair(BIG, 0);
            mx[alf - 1] = make_pair(BIG, 0);
            //cerr << mn[0].first << endl;
            for (int c = 1; c < alf; c++)
                mn[c] = min(mn[c - 1], go[0][c - 1][i][j]);
            for (int c = alf - 2; c >= 0; c--)
                mx[c] = min(mx[c + 1], go[0][c + 1][i][j]);
            //cerr << "kek\n";
            for (int c = 0; c < alf; c++)
            {
                if (c == 0)
                    f[c][i][j] = mx[c];
                else if (c == alf - 1)
                    f[c][i][j] = mn[c];
                else
                    f[c][i][j] = min(mn[c], mx[c]);
            }
        }
    /*for (int c = 0; c < alf; c++)
    {
        cerr << (char)(c + 'a') << endl;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
                cerr << f[c][i][j].first << " ";
            cerr << endl;
        }
        cerr << endl;
    }*/
}

int main()
{
    //freopen("test.in", "r", stdin);
    cin.sync_with_stdio(0);
    cin >> n >> m;
    s.resize(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    init_napr();
    init_two();
    //cerr << "kek";
    init_mn();
    int q;
    //return 0;
    cin >> q;
    for (int z = 0; z < q; z++)
    {
        int x, y;
        cin >> x >> y;
        x--, y--;
        int ans = BIG;
        int xa, ya, xb, yb;
        for (int c = 0; c < alf; c++)
            if (go[1][c][x][y].first < BIG && f[c][x][y].first < BIG)
            {
                //cerr << c << " " << go[1][c][x][y].first << " " << f[c][x][y].first<< endl;
                if (ans > go[1][c][x][y].first + f[c][x][y].first)
                {
                    ans = go[1][c][x][y].first + f[c][x][y].first;
                    if (go[1][c][x][y].second == 0)
                    {
                        ya = y;
                        xa = x - go[1][c][x][y].first;
                    }
                    else
                    {
                        ya = y;
                        xa = x + go[1][c][x][y].first;
                    }
                    if (f[c][x][y].second == 1)
                    {
                        yb = y + f[c][x][y].first;
                        xb = x;
                    }
                    else
                    {
                        yb = y - f[c][x][y].first;
                        xb = x;
                    }
                }
            }
        if (ans >= BIG)
        {
            cout << "-1\n";
            continue;
        }
        cout << xa + 1 << " " << ya + 1 << " " << xb + 1 << " " << yb + 1 << "\n";
    }
    return 0;
}
