#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <stdio.h>
#include <cassert>
#include <map>
#define SZ(v) (int)v.size()
#define p(x,y) pair<x,y>
#define X first
#define Y second
using namespace std;
const int N = 10000005;
const long long INF = (1LL << 61);
typedef long long ll;

ll n, r, now;
bool prime(ll x){
	for (ll i = 2; i*i <= x; i++)
		if (x%i == 0)return 0;
	return 1;
}
bool check(ll x){
	ll cnt = 1;
	ll xx = x;
	for (ll i = 2; i < 10000;i++){
		if (xx%i == 0 && prime(i)){
			ll cn = 1;
			while (xx % i == 0){
				cn++;
				xx /= i;
			}
			cnt *= cn;
			if (cnt > 99)return 1;
		}
	}
	return 0;
}
int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	cin >> n;
	r = n*1.01;
	if (check(n)){
		cout << n << endl;
		return 0;
	}
	if (check(r)){
		cout << r << endl;
		return 0;
	}
	for (int it = 0; it < 1000; it++){
		ll ch = n + rand() % (r - n + 1);
		if (check(ch)){
			cout << ch << endl;
			return 0;
		}
	}
	cout << -1 << endl;
}