#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vbool;
const ll INF = 1e18;

#define forn(i, b, n) for(ll i = b; i < n; ++i)

int main() {
	/*
	ll x;
	cin >> x;
	for (ll y = x; y <= x + x / 100; y++) {
		ll cur = 2;
		for (ll d = 2; d * d <= y; d++) {
			if (y % d == 0) {
				if (d * d == y) cur++; else cur += 2;
			}
		
		}
		if (cur >= 100) {
			cout << y << endl;
			return 0;
		}
	}
	cout << -1;
	*/
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	ll n, k;
	cin >> n >> k;
	vll lan(k);
	vector<vbool> g(n, vbool(k, 0));
	forn(i, 0, n) {
		ll m;
		cin >> m;
		forn(j, 0, m) {
			ll x;
			cin >> x;
			--x;
			g[i][x] = 1;
			lan[x]++;
		}
	}
	vvll d(n, vll(n, INF));
	forn(i, 0, n) {
		forn(j, 0, n) {
			if (i == j) {
				d[i][j] = 0;
				continue;
			}
			forn(kk, 0, k) {
				if (g[i][kk] && g[j][kk])
					d[i][j] = min(d[i][j], lan[kk] - 1);
			}
		}
	}
	forn(kk, 0, n) {
		forn(i, 0, n) {
			forn(j, 0, n) {
				if (d[i][j] > d[i][kk] + d[kk][j]) {
					d[i][j] = d[i][kk] + d[kk][j];
				}
			}
		}
	}
	forn(i, 0, n) {
		forn(j, 0, n) {
			if (d[i][j] == INF) cout << -1 << ' ';
			else {
				if (i != j) d[i][j]++;
				cout << d[i][j] << ' ';
			}
		}
		cout << '\n';
	}
	return 0;
}