#include <iostream>
#include <set>
#include <deque>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <cstring>
#include <ctime>
#include <map>

using namespace std;

typedef long long ll;

#define TL clock() * 1.0 / CLOCKS_PER_SEC

int solve();

void I();

int main(){
	//solve();
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	I();
}

struct q{
	int d[4];
	q(){}
};

vector<vector<q> > dp;
vector<string> field;
int n, m;


bool check(int i, int j){
	return 0 <= i && i < n && 0 <= j && j < m;
}


void print(int x, int y, int x2, int y2){
	printf("%d %d %d %d\n", x + 1, y + 1, x2 + 1, y2 + 1);
//	cout << x + 1 << ' ' << y + 1 << ' ' << x2 + 1 << ' ' << y2 + 1 << '\n';
}


int di[4] = { 0, 1, 0, -1 };
int dj[4] = { 1, 0, -1, 0 };


void I() {
	cin >> n >> m;
	field.resize(n);
	for (int i = 0; i < n; i++){
		cin >> field[i];
	}
	const int INF = 14881337;
	dp.resize(n, vector<q>(m));
	for (int i = 0; i < n; i++){
		for (int j = 0; j < m; j++){
			if (i == 0){
				dp[i][j].d[3] = INF;
			}
			else if (field[i - 1][j] != field[i][j]){
				dp[i][j].d[3] = 1;
			}
			else{
				dp[i][j].d[3] = dp[i - 1][j].d[3] + 1;
			}

			if (j == 0){
				dp[i][j].d[2] = INF;
			}
			else if (field[i][j - 1] != field[i][j]){
				dp[i][j].d[2] = 1;
			}
			else{
				dp[i][j].d[2] = dp[i][j - 1].d[2] + 1;
			}
		}
	}

	for (int i = n - 1; i >= 0; i--){
		for (int j = m - 1; j >= 0; j--){
			if (i == n - 1){
				dp[i][j].d[1] = INF;
			}
			else if (field[i + 1][j] != field[i][j]){
				dp[i][j].d[1] = 1;
			}
			else{
				dp[i][j].d[1] = dp[i + 1][j].d[1] + 1;
			}

			if (j == m - 1){
				dp[i][j].d[0] = INF;
			}
			else if (field[i][j + 1] != field[i][j]){
				dp[i][j].d[0] = 1;
			}
			else{
				dp[i][j].d[0] = dp[i][j + 1].d[0] + 1;
			}

			/*if (j == m - 1 || field[i][j + 1] == field[i][j]){
				dp[i][j].d[0] = 1;
			}
			else{
				dp[i][j].d[0] = dp[i][j + 1].d[0] + 1;
			}*/
		}
	}

	int q;
	cin >> q;
	for (int it = 0; it < q; it++){
		int qi, qj;
		scanf("%d%d", &qi, &qj);
		qi--;
		qj--;
		vector<pair<char, int> > w;
		for (int d = 0; d < 4; d++){
			if (check(qi + di[d], qj + dj[d])){
				w.push_back({ field[qi + di[d]][qj + dj[d]], d });
			}
		}
		sort(w.begin(), w.end());
		bool ok = 1;
		for (int i = 1; i < w.size(); i++){
			if (w[i].first != w[i - 1].first){
				print(
					qi + di[w[i].second],
					qj + dj[w[i].second],
					qi + di[w[i - 1].second],
					qj + dj[w[i - 1].second]);
				ok = 0;
				break;
			}
		}
		if (!ok){
			continue;
		}
		int dist = INF;
		int dans;
		for (int i = 0; i < w.size(); i++){
			int d = w[i].second;
			if (dist > 1 + dp[qi + di[d]][qj + dj[d]].d[d]){
				dist = 1 + dp[qi + di[d]][qj + dj[d]].d[d];
				dans = d;
			}
		}
		if (dist == INF){
			printf("-1\n");
			continue;
		}
		int d1 = (dans + 1) % 4;
		if (!check(qi + di[d1], qj + dj[d1])){
			d1 = (dans + 3) % 4;
		}
		print(
			qi + di[d1],
			qj + dj[d1],
			qi + di[dans] * (dist),
			qj + dj[dans] * (dist)
			);
	}
}