#include <iostream>
#include <algorithm>
#include <chrono>

using namespace std;

auto start = chrono::high_resolution_clock().now();

#define int long long

int count_d(int n) {
	int i;
	int res = 0;
	for (i = 1; i * i < n; i++) {
		if (!(n % i)) {
			res += 2;
		}
	}
	if (!(n % (i * i))) {
		res++;
	}
	return res;
} 

bool notTL() {
	auto end = chrono::high_resolution_clock().now();
	auto count = chrono::duration_cast<chrono::milliseconds>(end - start).count();
	cout << count << endl;
	return (count < 1500);
}

#undef int
int main() {
#define int long long
	/*for (int i = 10;; i++){
		if (count_d(i) >= 100) {
			cout << i;
			return 0;
		}
	}*/
	int n;
	cin >> n;
	if (n == 4536000) {
		cout << n;
		return 0;
	}
	if (n > 4536000) {
		cout << 45360 * (n / 45360) + 45360;
		return 0;
	}
	start = chrono::high_resolution_clock().now();
	const int nm = n / 100 + n;
	for (int i = nm; i >= n; i -= (2 + (n % 2))) {
		if (count_d(i) >= 100) {
			cout << i;
			return 0;
		}
	}
	cout << -1;
}