//#include <bits/stdc++.h>
#include <stdio.h>
#include <vector>
#include <algorithm>

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do {ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch > ' ') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

using namespace std;

const int MAXN = 1e5 + 227 + 1;
const int inf = 2e9;
//const int INFINT = 1e9 + 227 + 1;
//const long long INF = 1e18 + 227 + 1;
const int MOD = (int)1e9 + 7;

#define all(a) (a).begin(), (a).end()
#define f first
#define ll long long
#define s second
#define pb push_back
#define mp make_pair

int main() {
//    ios::sync_with_stdio(0);
//     freopen(".in", "r", stdin);
//    freopen(".out", "w", stdout);

    int n, m;
    scanf("%d %d", &n, &m);

    vector<vector<char> > a(n, vector<char>(m));

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            char c = '\n';
            while (c == '\n') {
                c = getchar();
            }

            a[i][j] = c - 'a';
        }
    vector<vector<int> > up[26], dw[26], lf[26], rf[26];
    for(int i = 0; i < 26; i++) {
        up[i] = vector<vector<int> >(n, vector<int>(m));
        dw[i] = up[i];
        lf[i] = up[i];
        rf[i] = up[i];
    }

    for (int k = 0; k < 26; k++) {
        for (int j = 0; j < m; j++) {
                up[k][0][j] = inf;
                dw[k][n - 1][j] = inf;
            }
        }

    for (int k = 0; k < 26; k++)
        for (int i = 0; i < n; i++) {
                lf[k][i][0] = inf;
                rf[k][i][m - 1] = inf;
            }

    for (int k = 0; k < 26; k++) {
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < m; j++)
                    if (a[i - 1][j] != k)
                        up[k][i][j] = 1;
                    else
                        up[k][i][j] = min(inf, up[k][i - 1][j] + 1);
                }
        }

    for (int k = 0; k < 26; k++) {
        for (int i = n - 2; i >= 0; i--) {
            for (int j = 0; j < m; j++)
                    if (a[i + 1][j] != k)
                        dw[k][i][j] = 1;
                    else
                        dw[k][i][j] = min(inf, dw[k][i + 1][j] + 1);
                }
        }

    for (int k = 0; k < 26; k++) {
        for (int j = 1; j < m; j++)
            for (int i = 0; i < n; i++)
                    if (a[i][j - 1] == k)
                        lf[k][i][j] = 1;
                    else
                        lf[k][i][j] = min(inf, lf[k][i][j - 1] + 1);
                }

    for (int j = m - 2; j >= 0; j--)
        for (int i = 0; i < n; i++)
            for (int k = 0; k < 26; k++) {
                if (a[i][j + 1] == k)
                    rf[k][i][j] = 1;
                else
                    rf[k][i][j] = min(inf, rf[k][i][j + 1] + 1);
            }
    int q;
    scanf("%d", &q);

    while (q--) {
        int x, y;
        x = next_int<int>();
        y = next_int<int>();
        x--, y--;
//        cout << x << ' ' << y;
//    return 0;

        pair<int, pair<int, int> > ans;
        ans.f = inf;

        for (int k = 0; k < 26; k++) {
            int alpha = lf[k][x][y];
            int beta = up[k][x][y];

            int type = 0;
            if (dw[k][x][y] < beta) {
                type = 1;
                beta = dw[k][x][y];
            }

            if (alpha != inf && beta != inf) {
                ans = min(ans, mp(alpha + beta, mp(type, alpha)));
            }

            type += 2;
            alpha = rf[k][x][y];
            if (alpha != inf && beta != inf) {
                ans = min(ans, mp(alpha + beta, mp(type, alpha)));
            }
        }

        if (ans.first == inf) {
            puts("-1");
            continue;
        }

        int type = ans.s.f;
        int alpha = ans.s.s;
        int beta = ans.f - alpha;

        if (type == 0) {
            int r1 = x - beta;
            int c2 = y - alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 1) {
            int r1 = x + beta;
            int c2 = y - alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 2) {
            int r1 = x - beta;
            int c2 = y + alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 3) {
            int r1 = x + beta;
            int c2 = y + alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
    }
    return 0;
}
