
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int N = 1e18;

int f, m;

int get(int num) {
	num = (num + (N - m)) % (N - m);
	cout << "? " << num + 1 << endl;
	int p; cin >> p;
	return p;
}

int num(int pos) {
	return (pos - f + N) % N;
}

long main() {
	int x; cin >> x;
	cin >> m;

	int x0 = x;

	f = get(0);
	x = num(x);

	int l = -1, r = m + 1;

	while (r - l > 1) {
		int mid = (l + r) / 2;
		int p = get(x - mid);
		if (num(p) > x)
			l = mid + 1;
		else if (num(p) < x)
			r = mid;
		else {
			cout << "! " << (x - mid + N) % N + 1 << endl;
			return 0;
		}
	}
	if (l == -1) {
		cout << -1 << endl;
		return 0;
	}

	cout << "! " << (x - l + N) % N + 1 << endl;

	return 0;
}