#include <stdio.h>
#include <cctype>
#include <inttypes.h>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

/*<--------------------------------------------------------------------------->*/

const int MIN_GOOD = 45360;

int divs_cnt(int x)
{
    int ans = 1;
    for (int i = 2; i*i <= x; ++i)
    {
        int cnt = 1;
        while (x%i == 0)
            x /= i,
            cnt++;
        ans *= cnt;
    }
    if (x > 1)
        ans *= 2;
    return ans;
}

void solve()
{
    int64_t x;
    scanf("%lld", &x);
    if (x > MIN_GOOD * 100)
        printf("%lld\n", ((x + MIN_GOOD - 1) / MIN_GOOD) * MIN_GOOD);
    else
    {
        int mx = (x*101)/100;
        for (int i = x; i <= mx; ++i)
            if (divs_cnt(i) >= 100)
            {
                printf("%d\n", i);
                return;
            }
        printf("-1\n");
    }
}

/*<--------------------------------------------------------------------------->*/

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
