#include <stdio.h>
#include <bits/stdc++.h>

#define X first
#define Y second
#define all(v) v.begin(), v.end()
#define SZ(v) (int)(v.size())
#define pb push_back

using namespace std;

typedef pair<int, int> ii;
typedef long long ll;

const int INF = 1000000000;
/*
struct segTree {
    int n;
    vector<int> tr;
    segTree(int N) {
        n = N;
        tr.resize(2*n,0);
    }
    void upd(int v, int val) {
        v+=n;
        if(!val)tr[v]=v-n;
        else tr[v]=INF;
        for(v>>=1; v; v>>=1)
            tr[v]=min(tr[v*2],tr[v*2+1]);
    }
    int get(int l, int r) {
        int res=INF;
        for(l+=n, r+=n; l<=r; l=(l+1)>>1, r=(r-1)>>1) {
            if(l&1) res=min(res,tr[l]);
            if(!(r&1)) res=min(res,tr[r]);
        }
        return res;
    }
};
*/
struct ev {
    int t,ty,id;
    ev(){}
    ev(int t, int ty, int id):t(t),ty(ty),id(id){}
    bool operator < (const ev & x) const {
        return t<x.t||t==x.t&&ty<x.ty;
    }
};

int main() {
 //   freopen("input.txt", "r", stdin);
    int n, m, k;
    cin>>n>>m>>k;
    vector<ev> a;
    vector<int> sit(k);
    for(int i=0; i<k; i++) {
        int f,l;
        cin>>f>>l;
        a.pb(ev(f,1,i));
        a.pb(ev(l,0,i));
        sit[i]=l-f;
    }
    vector<int> pos(k,INF);
    vector<int> spent(2*m,0);
    stable_sort(all(a));
    set<int> fr;
    for(int i=0; i<2*m; i++)
        fr.insert(i);
    for(ev now:a)
        if(now.ty==1) {
            if(fr.empty())continue;
            int w = *fr.begin();
            pos[now.id]=w;
            fr.erase(fr.begin());
        } else {
            int w=pos[now.id];
            if(w==INF)continue;
            fr.insert(w);
            spent[w]+=sit[now.id];
        }
    int o=INF, oi=-1;
    for(int i=0; i<m; i++) {
        int nt = spent[i + m - 1];
        if(nt < o) {
            o=nt; oi=i;
        }
    }
    return cout<<o<<' '<<oi+1,0;
}
