#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double ld;
#define endl "\n"

inline void read(int &n) {
	n = 0;
	char c;
	while (true) {
		c = getchar();
		if (c == ' ' || c == '\n')
			break;
		n = n * 10 + (c - '0');
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(NULL));
	cout.precision(10);
#if __cplusplus == 201103
	freopen("input.txt", "r", stdin);
#else

#endif

	int n, m;
	read(n);
	read(m);

	char ar[n + 2][m + 2];
	memset(ar, 0, sizeof(ar));
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			ar[i][j] = getchar();
		}
		getchar();
	}

	int dp[4][n + 2][m + 2];
	memset(dp, 0, sizeof(dp));
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			dp[0][i][j] = (ar[i][j] != ar[i - 1][j] ? i - 1 : dp[0][i - 1][j]);
			dp[1][i][j] = (ar[i][j] != ar[i][j - 1] ? j - 1 : dp[1][i][j - 1]);
		}
	}
	for (int i = 1; i <= n; i++) {
		dp[2][i][m + 1] = m + 1;
	}
	for (int j = 1; j <= m; j++) {
		dp[3][n + 1][j] = n + 1;
	}
	for (int i = n; i; i--) {
		for (int j = m; j; j--) {
			dp[2][i][j] = (ar[i][j] != ar[i][j + 1] ? j + 1 : dp[2][i][j + 1]);
			dp[3][i][j] = (ar[i][j] != ar[i + 1][j] ? i + 1 : dp[3][i + 1][j]);
		}
	}

	int t;
	read(t);
	const int MAX = 1e8;
	while (t--) {
		int x, y, x1, y1, x2, y2;
		read(x);
		read(y);
		int ans = MAX;
		if (x > 1 && y > 1 && ar[x - 1][y] != ar[x][y - 1]) {
			ans = 1;
			x1 = x - 1, y1 = y;
			x2 = x, y2 = y - 1;
		}
		if (x > 1 && y < m && ar[x - 1][y] != ar[x][y + 1]) {
			ans = 1;
			x1 = x - 1, y1 = y;
			x2 = x, y2 = y + 1;
		}
		if (x < n && y > 1 && ar[x + 1][y] != ar[x][y - 1]) {
			ans = 1;
			x1 = x + 1, y1 = y;
			x2 = x, y2 = y - 1;
		}
		if (x < n && y < m && ar[x + 1][y] != ar[x][y + 1]) {
			ans = 1;
			x1 = x + 1, y1 = y;
			x2 = x, y2 = y + 1;
		}
		if (x > 1) {
			if (y > 1 && ar[x - 1][y] == ar[x][y - 1] && dp[1][x][y - 1] > 0
					&& y - dp[1][x][y - 1] + 1 < ans) {
				ans = y - dp[1][x][y - 1] + 1;
				x1 = x - 1, y1 = y;
				x2 = x, y2 = dp[1][x][y - 1];
			}
			if (y < m && ar[x - 1][y] == ar[x][y + 1] && dp[2][x][y + 1] <= m
					&& dp[2][x][y + 1] - y + 1 < ans) {
				ans = dp[2][x][y + 1] - y + 1;
				x1 = x - 1, y1 = y;
				x2 = x, y2 = dp[2][x][y + 1];
			}
		}
		if (x < n) {
			if (y > 1 && ar[x + 1][y] == ar[x][y - 1] && dp[1][x][y - 1] > 0
					&& y - dp[1][x][y - 1] + 1 < ans) {
				ans = y - dp[1][x][y - 1] + 1;
				x1 = x + 1, y1 = y;
				x2 = x, y2 = dp[1][x][y - 1];
			}
			if (y < m && ar[x + 1][y] == ar[x][y + 1] && dp[2][x][y + 1] <= m
					&& dp[2][x][y + 1] - y + 1 < ans) {
				ans = dp[2][x][y + 1] - y + 1;
				x1 = x + 1, y1 = y;
				x2 = x, y2 = dp[2][x][y + 1];
			}
		}
		if (y > 1) {
			if (x > 1 && ar[x][y - 1] == ar[x - 1][y] && dp[0][x - 1][y] > 0
					&& x - dp[0][x - 1][y] + 1 < ans) {
				ans = x - dp[0][x - 1][y] + 1;
				x1 = x, y1 = y - 1;
				x2 = dp[0][x - 1][y], y2 = y;
			}
			if (x < n && ar[x][y - 1] == ar[x + 1][y] && dp[3][x + 1][y] <= n
					&& dp[3][x + 1][y] - x + 1 < ans) {
				ans = dp[3][x + 1][y] - x + 1;
				x1 = x, y1 = y - 1;
				x2 = dp[3][x + 1][y], y2 = y;
			}
		}
		if (y < m) {
			if (x > 1 && ar[x][y + 1] == ar[x - 1][y] && dp[0][x - 1][y] > 0
					&& x - dp[0][x - 1][y] + 1 < ans) {
				ans = x - dp[0][x - 1][y] + 1;
				x1 = x, y1 = y + 1;
				x2 = dp[0][x - 1][y], y2 = y;
			}
			if (x < n && ar[x][y + 1] == ar[x + 1][y] && dp[3][x + 1][y] <= n
					&& dp[3][x + 1][y] - x + 1 < ans) {
				ans = dp[3][x + 1][y] - x + 1;
				x1 = x, y1 = y + 1;
				x2 = dp[3][x + 1][y], y2 = y;
			}
		}
		if(ans == MAX){
			cout << -1 << endl;
		}else{
			cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
		}
	}

}
