#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define rep(i,x,y) for(int i = x; i <= y; ++i)
#define repr(i,x,y) for(int i = x; i >= y; --i)
#define forn(i,x,y) for(int i = x; i <= y; ++i)
#define forev(i,x,y) for(int i = x; i >= y; --i)
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()
                    
typedef long long ll;

using namespace std;

const int N = (int)(5e5) + 322;
const int maxn = (int)(5e5) + 100;
const int INF = (int)(1e9) + 7;
const double eps = 1e-9;

int n, m;
            
vector <string> s;

// 0 -> up
// 1 -> down
// 2 -> left 
// 3 -> right

struct point {
	int x, y, mn;
	point() {
		x = 0, y = 0, mn = INF;
	}
}; 

inline void upd(point &a,const int &x,const int &y,const int &mn) {
	if (x <= 0 || x > n || y <= 0 || y > m) return;
	if (mn > a.mn) return;
	a.mn = mn;
	a.x = x;
	a.y = y;
}

vector <vector <int> > dp[26][4];

int main () {
	ios_base :: sync_with_stdio(false); cin.tie(0);
//	freopen(".in", "r", stdin);
		
	cin >> n >> m;
	s.resize(n + 1);
	rep(i, 1, n) {
		cin >> s[i];
		s[i] = '#' + s[i];
	}
	rep(ch, 0, 25) {
		rep(j, 0, 3) {
			forn (i, 0, n + 1)
			dp[ch][j].pb(vector <int> ());
			rep(i, 0, n + 1)
				forn (k, 0, m + 1)
				 	dp[ch][j][i].pb(0);
		}
	}
		
	rep(i, 1, n) {
		rep(j, 1, m) {
			rep(ch, 0, 25) {
				dp[ch][0][i][j] = dp[ch][0][i - 1][j] + 1;				
				dp[ch][2][i][j] = dp[ch][2][i][j - 1] + 1;
			}
			dp[s[i][j] - 97][0][i][j] = 0;
			dp[s[i][j] - 97][2][i][j] = 0; 
		}
	}
	repr(i, n, 1) {
		repr(j, m, 1) {
			rep(ch, 0, 25) {
				dp[ch][1][i][j] = dp[ch][1][i + 1][j] + 1;
				dp[ch][3][i][j] = dp[ch][3][i][j + 1] + 1; 
			}
			dp[s[i][j] - 97][1][i][j] = 0;
			dp[s[i][j] - 97][3][i][j] = 0;
		}
	}
// 0 -> up
// 1 -> down
// 2 -> left 
// 3 -> right
	
	int q; cin >> q;
	rep(ii, 1, q) {
		int x, y; cin >> x >> y;
		int ch = s[x][y] - 97, mn = INF;
		int x1, y1, x2, y2;
		rep(i, 0, 25) {
			point ud;
			upd(ud, x - dp[i][0][x - 1][y] - 1, y, dp[i][0][x - 1][y] + 1);
			upd(ud, x + dp[i][1][x + 1][y] + 1, y, dp[i][1][x + 1][y] + 1);
			if (ud.mn == INF) continue;
			rep(j, 0, 25) {
				if (i == j) continue;
				point lr;
				upd(lr, x, y + dp[j][3][x][y + 1] + 1, dp[j][3][x][y + 1] + 1);
				upd(lr, x, y - dp[j][2][x][y - 1] - 1, dp[j][2][x][y - 1] + 1);
				if (lr.mn == INF) continue;
				if (lr.mn + ud.mn < mn) {
					mn = lr.mn + ud.mn;
					x1 = lr.x;
					y1 = lr.y;
					x2 = ud.x;
					y2 = ud.y;
				}						
			}																
		}				
		if (mn == INF) {
			cout << -1 << endl;
			continue;
		}
		cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
	} 
	return 0;
}