#include <bits/stdc++.h>

#define fi first
#define se second
#define sc scanf
#define pr printf
#define pb push_back

const int N = 200200;

using namespace std;

int n, m;
int ax[2], ay[2], ans;

void upd(int x1, int y1, int x2, int y2)
{
    if(!x1 || !y1 || !x2 || !y2 || x1 > n || x2 > n || y1 > m || y2 > m)
        return;
    if(abs(x1 - x2) + abs(y1 - y2) < ans){
        ans = abs(x1 - x2) + abs(y1 - y2);
        ax[0] = x1;
        ay[0] = y1;
        ax[1] = x2;
        ay[1] = y2;
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin >> n >> m;
    vector < vector < char > > c;
    vector < vector < int > > d1, d2, d3, d4;
    c.resize(n + 2);
    d1.resize(n + 2);
    d2.resize(n + 2);
    d3.resize(n + 2);
    d4.resize(n + 2);
    for(int i = 0; i <= n + 1; i++){
        c[i].resize(m + 2);
        d1[i].resize(m + 2);
        d2[i].resize(m + 2);
        d3[i].resize(m + 2);
        d4[i].resize(m + 2);
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            cin >> c[i][j];
        }
    }
    for(int i = 0; i <= n + 1; i++)
        for(int j = 0; j <= m + 1; j++)
            d1[i][j] = d2[i][j] = d3[i][j] = d4[i][j] = 0;
    //left
    for(int i = 1; i <= n; i++){
        for(int j = 2; j <= m; j++){
            if(c[i][j - 1] != c[i][j - 2])
                d1[i][j] = j - 2;
            else
                d1[i][j] = d1[i][j - 1];
        }
    }
    //right
    for(int i = 1; i <= n; i++){
        for(int j = m - 1; j >= 1; j--){
            if(c[i][j + 1] != c[i][j + 2])
                d2[i][j] = j + 2;
            else
                d2[i][j] = d2[i][j + 1];
        }
    }
    //up
    for(int i = 2; i <= n; i++){
        for(int j = 1; j <= m; j++){
            if(c[i - 1][j] != c[i - 2][j])
                d3[i][j] = i - 2;
            else
                d3[i][j] = d3[i - 1][j];
        }
    }
    //down
    for(int i = n - 1; i >= 1; i--){
        for(int j = 1; j <= m; j++){
            if(c[i + 1][j] != c[i + 2][j])
                d4[i][j] = i + 2;
            else
                d4[i][j] = d4[i + 1][j];
        }
    }
    int q;
    cin >> q;
    while(q--){
        int x, y;
        ans = 1e9;
        cin >> x >> y;
        //if(c[x][d1[x][y]] != c[x][y])upd(x, d1[x][y], x, y);
        //if(c[x][d2[x][y]] != c[x][y])upd(x, d2[x][y], x, y);
        //if(c[d3[x][y]][y] != c[x][y])upd(d3[x][y], y, x, y);
        //if(c[d4[x][y]][y] != c[x][y])upd(d4[x][y], y, x, y);
        if(c[x][y - 1] == c[x - 1][y])upd(x, d1[x][y], x - 1, y), upd(x, y - 1, d3[x][y], y);
        else upd(x, y - 1, x - 1, y);
        if(c[x][y - 1] == c[x + 1][y])upd(x, d1[x][y], x + 1, y), upd(x, y - 1, d4[x][y], y);
        else upd(x, y - 1, x + 1, y);
        if(c[x][y + 1] == c[x - 1][y])upd(x, d2[x][y], x - 1, y), upd(x, y + 1, d3[x][y], y);
        else upd(x, y + 1, x - 1, y);
        if(c[x][y + 1] == c[x + 1][y])upd(x, d2[x][y], x + 1, y), upd(x, y + 1, d4[x][y], y);
        else upd(x, y + 1, x + 1, y);
        if(ans == 1e9)
            cout << -1 << endl;
        else
            cout << ax[0] << " " << ay[0] << " " << ax[1] << " " << ay[1] << endl;
    }
}
