#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define f first
#define S second
#define s second
#define forn(i, x, n) for (int i = int(x); i <= int(n); ++i)
#define for1(i, n, x) for (int i = int(n); i >= int(n); --i)
#define fname ""
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef pair <int, int> PII;
typedef pair <int, int> pi;
typedef double ld;

const int N = 2e5 + 5;
const int MAX_N = 2e5 + 1;
const int INF = 1e9 + 9;
const int inf = 1e9 + 9;
const int mod = 1e9 + 7;

int n, m, k, res, len[N], in[N];
pair < int, int > t[N];

map < int, vector < int > > del, add;
vector < int > all;
set < int > st[2];

void Add(int x, int p)
{
	if (st[0].size() + st[1].size() == 0) return;
	in[x] = 1;
	if (st[0].size())
	{
		int now = *st[0].begin();
		st[0].erase(now);
		t[x] = mp(0, now);
	}
	else
	{
		int now = *st[1].begin();
		st[1].erase(now);
		if (now == p) res += len[x];
		t[x] = mp(1, now);
	}
}
void Del(int x)
{
	if (!in[x]) return;
	st[t[x].f].insert(t[x].s);
}

int f(int p)
{
	st[0].clear();
	st[1].clear();
	for (int i = 1;i <= m;i++)
	{
		in[i] = 0;
		if (i != p) st[0].insert(i);
		st[1].insert(i);
	}
	res = 0;
	for (auto i : all)
	{
		if (del.count(i))
		{
			for (auto j : del[i]) Del(j);
		}
		if (add.count(i))
		{
			for (auto j : add[i]) Add(j, p);
		}
	}
	return res;
}

int main() {
	#ifdef LBN
		freopen("in", "r", stdin);
	#else
	//	freopen(fname"in", "r", stdin);
	//	freopen(fname"out", "w", stdout);
	#endif // LBN
	ios_base :: sync_with_stdio(0);
	cin >> n >> m >> k;
	for (int i = 1;i <= k;i++)
	{
		int l, r;
		cin >> l >> r;
		len[i] = r - l;
		add[l].pb(i);
		del[r].pb(i);
		all.pb(l);
		all.pb(r);
	}
	sort(all.begin(), all.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());
	int l = 1, r = m;
	int x = f(m), ans = -1;
	while(l <= r)
	{
		int mid = (l + r) / 2;
		if (f(mid) == x)
		{
			r = mid - 1;
			ans = mid;
		}
		else l = mid + 1;
	}
	cout << x << " " << ans << endl;
	return 0;
}
