#include <bits/stdc++.h>

using namespace std;

typedef pair<int, int> pii;

const int INF = 1e9;

void get_ans(int n)
{
    int m;
    scanf("%d", &m);
    int field[n][m];
    for (int i = 0; i < n; ++i)
    {
        char s[m + 2];
        scanf("%s", &s);
        for (int j = 0; j < m; ++j)
            field[i][j] = s[j] - 'a';
    }
    int dpu[26][n][m];
    int dpl[26][n][m];
    int dpd[26][n][m];
    int dpr[26][n][m];
    for (int k = 0; k < 26; ++k)
    {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
            {
                if (i == 0)
                    dpu[k][i][j] = INF;
                else if (field[i - 1][j] == k)
                    dpu[k][i][j] = 1;
                else
                    dpu[k][i][j] = dpu[k][i - 1][j] + 1;                    
            }    
    }
    for (int k = 0; k < 26; ++k)
    {
        for (int i = n - 1; i >= 0; --i)
            for (int j = 0; j < m; ++j)
            {
                if (i == n - 1)
                    dpd[k][i][j] = INF;
                else if (field[i + 1][j] == k)
                    dpd[k][i][j] = 1;
                else
                    dpd[k][i][j] = dpd[k][i + 1][j] + 1;                    
            }    
    }
    for (int k = 0; k < 26; ++k)
    {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
            {
                if (j == 0)
                    dpl[k][i][j] = INF;
                else if (field[i][j - 1] == k)
                    dpl[k][i][j] = 1;
                else
                    dpl[k][i][j] = dpl[k][i][j - 1] + 1;                    
            }    
    }
    for (int k = 0; k < 26; ++k)
    {
        for (int i = 0; i < n; ++i)
            for (int j = m - 1; j >= 0; --j)
            {
                if (j == m - 1)
                    dpr[k][i][j] = INF;
                else if (field[i][j + 1] == k)
                    dpr[k][i][j] = 1;
                else
                    dpr[k][i][j] = dpr[k][i][j + 1] + 1;                    
            }    
    }
    int q;
    scanf("%d", &q);
    for (int i = 0; i < q; ++i)
    {
        int x, y;
        scanf("%d %d", &x, &y);
        --x, --y;
        int mi1 = -1, mi2 = -1, minans1 = 2 * INF, minans2 = 2 * INF;
        for (int k = 0; k < 26; ++k)
        {
            int now = min(dpu[k][x][y], dpd[k][x][y]);
            if (now <= minans1)
            {
                mi2 = mi1;
                mi1 = k;
                minans2 = minans1;
                minans1 = now;
            }
            else if (now <= minans2)
            {
                mi2 = k;
                minans2 = now;
            }                 
        }
        int u1 = mi1, u2 = mi2, ua1 = minans1, ua2 = minans2;
        mi1 = -1, mi2 = -1, minans1 = 2 * INF, minans2 = 2 * INF;
        for (int k = 0; k < 26; ++k)
        {
            int now = min(dpl[k][x][y], dpr[k][x][y]);
            if (now <= minans1)
            {
                mi2 = mi1;
                mi1 = k;
                minans2 = minans1;
                minans1 = now;
            }
            else if (now <= minans2)
            {
                mi2 = k;
                minans2 = now;
            }                 
        }
        int ansu, ansr;
        int r1 = mi1, r2 = mi2, ra1 = minans1, ra2 = minans2;
        if (r1 != u1)
            ansu = u1, ansr = r1;
        else if (ra1 + ua2 > ra2 + ua1)
            ansu = u1, ansr = r2;
        else           
            ansu = u2, ansr = r1;
        int ans = min(dpl[ansr][x][y], dpr[ansr][x][y]) + min(dpu[ansu][x][y], dpd[ansu][x][y]);;
        if (ans >= INF)
            printf("-1\n");
        else
        {
            int up = dpd[ansu][x][y];
            if (dpd[ansu][x][y] > dpu[ansu][x][y])
                up = -dpu[ansu][x][y];    
            int left = dpr[ansr][x][y];
            if (dpr[ansr][x][y] > dpl[ansr][x][y])
                left = -dpl[ansr][x][y];    
           // cout << ansr << " " << ansu << "\n";
            printf("%d %d %d %d\n", x + 1 + up, y + 1, x + 1, y + 1 + left);
        }
    }
}

int main()
{                                                     
//    freopen("1.in", "r", stdin);
//    freopen("1.out", "w", stdout);
    int n;
    while (scanf("%d", &n) == 1)
        get_ans(n);
    return 0;
}