#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int main() {
#ifdef _DEBUG
	freopen("output.txt", "w", stdout);
#endif
	vector<int> x(3);
	cin >> x[0] >> x[1] >> x[2];

	long long sum = x[0] + (long long)x[1] + x[2];

	if (sum % 2) {
		cout << -1 << endl;
		return 0;
	}

	for (int i = 0; i < 3; ++i) {
		int j = (i + 1) % 3, k = (i + 2) % 3;
		if (x[i] == x[j] + x[k]) {
			cout << 0 << endl;
			return 0;
		}
	}
	
	sum /= 2;

	for (int i = 0; i < 3; ++i) {
		int xf = x[(i + 1) % 3], xs = x[(i + 2) % 3];

		if (x[i] == sum - xf + sum - xs && sum - xs >= 0 && sum - xf >= 0) {
			cout << i + 1 << endl;
			cout << sum - xf << ' ' << sum - xs << endl;
			return 0;
		}
	}

	cout << -1 << endl;
	

	return 0;
}