#include <iostream>

using namespace std;

using ll = long long;

const ll e = 1000000000000000000;
ll x, m;

ll magic(ll a)
{
    while (a <= 0) {
        a += e-m;
    }
    while (a > e-m) {
        a -= e-m;
    }
    return a;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> x >> m;
    cout << "? 1" << endl;
    ll a;
    cin >> a;
    if (x == a) {
        cout << "! 1" << endl;
        return 0;
    }
    if (x > a) {
        int l = 0, r = m+1, mb;
        while (r-l > 1) {
            mb = (l+r)/2;
            cout << "? " << magic(x-a+1-mb) << endl;
            ll y;
            cin >> y;
            if (y == x) {
                cout << "! " << magic(x-a+1-mb) << endl;
                return 0;
            } else if (magic(y-a) < magic(x-a)) {
                r = mb;
            } else {
                l = mb;
            }
        }
        cout << "? " << magic(x-a+1-l) << endl;
        ll y;
        cin >> y;
        if (y == x) {
            cout << "! " << magic(x-a+1-l) << endl;
            return 0;
        }
        cout << "! -1" << endl;
    } else {
        int l = 0, r = m+1, mb;
        while (r-l > 1) {
            mb = (l+r)/2;
            cout << "? " << magic(x-a+1-mb) << endl;
            ll y;
            cin >> y;
            if (y == x) {
                cout << "! " << magic(x-a+1-mb) << endl;
                return 0;
            } else if (magic(a-y) > magic(a-x)) {
                r = mb;
            } else {
                l = mb;
            }
        }
        cout << "? " << magic(x-a+1-l) << endl;
        ll y;
        cin >> y;
        if (y == x) {
            cout << "! " << magic(x-a+1-l) << endl;
            return 0;
        }
        cout << "! -1" << endl;
    }
    return 0;
}
