#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:25600000")
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

#define TASK ""

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	return solve();
};

int solve() {
	int n, k, m;
	scanf("%d %d %d", &n, &k, &m);
	vector<int> g(m);
	for (int i = 0; i < m; i++) {
		scanf("%d", &g[i]);
	}
	sort(g.begin(), g.end());
	int ans1 = g[0] - 1;
	int lst = 0;
	for (int i = 1; i < m; i++) {
		if (g[lst] + k - 1 >= g[i]) {
			continue;
		}
		else {
			ans1 += max(0, g[i] - g[lst] - k);
			lst = i;
		}
	}
	ans1 += max(0, n - g[lst] - k + 1);
	int ans2 = 0;
	int l = 0, r = m - 1;
	while (l < m && g[l] <= k) {
		l++;
	}
	while (r >= 0 && n - g[r] < k) {
		r--;
	}
	if (l == m && g[l - 1] <= k) {
		printf("%d", max(ans1, n - g[m - 1]));
		return 0;
	}
	if (l)
		ans2 += g[l] - g[l - 1] - 1;
	else
		ans2 += g[l] - 1;
	lst = l;
	for (int i = l + 1; i < r; i++) {
		if (g[lst] + k - 1 >= g[i])
			continue;
		else {
			ans2 += max(0, g[i] - g[lst] - k);
			lst = i;
		}
	}
	if (r == m - 1) {
		ans2 += max(0, n - g[lst] - k + 1);
	}
	printf("%d", max(ans1, ans2));
	return 0;
}
