#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
} init;
#define abs(a) ((a) >= 0 ? (a) : -(a))
const int  MAXA = 26;
struct kal{
    int c1 = -1, wc1 = -1, c2 = -1, wc2 = -1;
    kal(){}
};
const int MAXN = 5e5 + 2;
vector<kal> col[MAXN];
vector<kal> row[MAXN];
vector<char> f[MAXN];
vector<pair<int, char>> ans[MAXN];
int up[MAXA][MAXN];
int left[MAXA][MAXN];

int main() {
//    dbg(1000000 * 26 * 4 * 6, 1000000 * 26 * 4 * 2);
    int n, m;
//    cin >> n >> m;
scanf("%d%d", &n, &m);
for (int i = 0; i <= n + 1; ++i) {
    row[i].resize(m + 2);
    f[i].resize(m + 2);
}
for (int i = 0; i <= m + 1; ++i)
    col[i].resize(n + 2);

    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {scanf("%c", &f[i][j]);ans[j].clear();}

//            cin >> f[i][j];
        for (int c= 0; c < MAXA; ++c) {
            {int prev = -1;
            for (int j = 1; j <= m; ++j) {
                left[c][j] = prev;
                if (f[i][j] == c + 'a')
                    prev = j;
            }}
            {int prev = -1;
            for (int j = m; j >= 1; --j) {
                int right = prev;
                if (f[i][j] == c + 'a')
                    prev = j;
                if (left[c][j] == -1)
                    left[c][j] = right;
                else if(right == -1)
                    left[c][j] = left[c][j];
                else
                    left[c][j] = j - left[c][j] < right - j ? left[c][j] : right;
                if(left[c][j] != -1)
                    ans[j].pb(left[c][j], c);
            }}
        }
        for (int j = 1; j <= m; ++j)
        {
            for (pii p : ans[j]) {
                if (row[i][j].c1 == -1 || abs(p.ff - j) < abs(j - row[i][j].wc1)) {
                    row[i][j].wc2 = row[i][j].wc1;
                    row[i][j].c2 = row[i][j].c1;
                    row[i][j].wc1 = p.ff;
                    row[i][j].c1 = p.ss;
                }
                else if (row[i][j].c2 == -1 || abs(p.ff - j) < abs(j - row[i][j].wc2)) {
                    row[i][j].wc2 = p.ff;
                    row[i][j].c2 = p.ss;
                }
            }
        }
    }

    for (int j = 1; j <= m; ++j) {
                for (int i = 1; i <= n; ++i)
                        ans[i].clear();
        for (int c= 0; c < MAXA; ++c) {
            {
                int prev = -1;
                for (int i = 1; i <= n; ++i) {
                    up[c][i] = prev;
                    if (f[i][j] == c + 'a')
                        prev = i;
                }
            }
            {
                int prev = -1;
                for (int i = n; i >= 1; --i) {
                    int down = prev;
                    if (f[i][j] == c + 'a')
                        prev = i;
                    if (up[c][i] == -1)
                        up[c][i] = down;
                    else if (down == -1)
                        up[c][i] = up[c][i];
                    else
                        up[c][i] = i - up[c][i] < down - i ? up[c][i]  : down;
                    if (up[c][i] != -1)
                        ans[i].pb(up[c][i], c);
                }
            }
        }
        for (int i = 1; i <= n; ++i)
        {
            for (pii p : ans[i]) {
                if (col[j][i].c1 == -1 || abs(p.ff - i) < abs(i - col[j][i].wc1)) {
                    col[j][i].wc2 = col[j][i].wc1;
                    col[j][i].c2 = col[j][i].c1;
                    col[j][i].wc1 = p.ff;
                    col[j][i].c1 = p.ss;
                }
                else if (col[j][i].c2 == -1 || abs(p.ff - i) < abs(i - col[j][i].wc2)) {
                    col[j][i].wc2 = p.ff;
                    col[j][i].c2 = p.ss;
                }
            }
        }
    }
    int q;
//    cin >> q;
scanf("%d", &q);
    while (q--) {
        int x, y;
        scanf("%d%d", &x, &y);
//        cin >> x >> y;
        int mn = 1e9, wc1, wc2;
        if (row[x][y].c1 != col[y][x].c1 && row[x][y].c1 != -1 && col[y][x].c1 != -1) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[y][x].wc1 - x);
            if (mn > pot)
                mn = pot;
        }
        if (row[x][y].c1 != col[y][x].c2 && row[x][y].c1 != -1 && -1 != col[y][x].c2) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[y][x].wc2 - x);
            if (mn > pot)
                mn = pot;
        }
        if (row[x][y].c2 != col[y][x].c1 && row[x][y].c2 != -1 && -1 != col[y][x].c1) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[y][x].wc1 - x);
            if (mn > pot)
                mn = pot;
        }
        if (row[x][y].c2 != col[y][x].c2 && row[x][y].c2 != -1 && -1 != col[y][x].c2) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[y][x].wc2 - x);
            if (mn > pot)
                mn = pot;
        }
        if (mn == 1e9)
            printf("-1\n");
//            cout << "-1\n";
        else {

        if (row[x][y].c1 != col[y][x].c1 && row[x][y].c1 != -1 && col[y][x].c1 != -1) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[y][x].wc1 - x);
            if (mn == pot){printf("%d %d %d %d\n", x ,row[x][y].wc1 ,col[y][x].wc1 ,y);continue;}
        }
        if (row[x][y].c1 != col[y][x].c2 && row[x][y].c1 != -1 && -1 != col[y][x].c2) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[y][x].wc2 - x);
            if (mn == pot){printf("%d %d %d %d\n", x ,row[x][y].wc1 ,col[y][x].wc2 ,y);continue;}
        }
        if (row[x][y].c2 != col[y][x].c1 && row[x][y].c2 != -1 && -1 != col[y][x].c1) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[y][x].wc1 - x);
            if (mn == pot){printf("%d %d %d %d\n", x ,row[x][y].wc2,col[y][x].wc1 ,y);continue;}
        }
        if (row[x][y].c2 != col[y][x].c2 && row[x][y].c2 != -1 && -1 != col[y][x].c2) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[y][x].wc2 - x);
            if (mn == pot){printf("%d %d %d %d\n", x ,row[x][y].wc2 ,col[y][x].wc2 ,y);continue;}
        }
        }
    }

    return 0;
}
/*
3 4
abbb
baab
babb
4
1 1
1 4
3 1
3 4

*/
