#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
} init;

const int  MAXA = 26;
struct kal{
    int c1 = -1, wc1 = -1, c2 = -1, wc2 = -1;
    kal(){}
};
int main() {
//    dbg(1000000 * 26 * 4 * 6, 1000000 * 26 * 4 * 2);
    int n, m;
    cin >> n >> m;
    vector<vector<char>> f(n + 2);
    vector<vector<kal>> col(n + 2, vector<kal>(MAXA));
    vector<vector<kal>> row(n + 2, vector<kal>(MAXA));
    for (int i = 1; i <= n; ++i) {
        f[i].resize(m + 2);
        for (int j = 1; j <= m; ++j)
            cin >> f[i][j];
        vector<vector<pair<int, char>>> ans(m + 2);
        vector<vector<int>> left(MAXA, vector<int>(m + 2));
        for (int c= 0; c < MAXA; ++c) {
            {int prev = -1;
            for (int j = 1; j <= m; ++j) {
                left[c][j] = prev;
                if (f[i][j] == c + 'a')
                    prev = j;
            }}
            {int prev = -1;
            for (int j = m; j >= 1; --j) {
                int right = prev;
                if (f[i][j] == c + 'a')
                    prev = j;
                if (left[c][j] == -1)
                    left[c][j] = right;
                else if(right == -1)
                    left[c][j] = left[c][j];
                else
                    left[c][j] = j - left[c][j] < right - j ? left[c][j] : right;
                    if(left[c][j] != -1)
                ans[j].pb(left[c][j], c);
            }}
        }
        for (int j = 1; j <= m; ++j)
        {
            sort(ans[j].begin(), ans[j].end(), [j](const pii & p1, const pii & p2){
                    return abs(p1.ff - j) < abs(p2.ff - j);
            });
            if (!ans[j].empty()) {
                row[i][j].c1 = ans[j][0].ss, row[i][j].wc1 = ans[j][0].ff;
            }
            if (ans[j].size() >= 2)
                row[i][j].c2 = ans[j][1].ss, row[i][j].wc2 = ans[j][1].ff;
        }
    }

    for (int j = 1; j <= m; ++j) {
        vector<vector<pair<int, char>>> ans(n + 2);
        vector<vector<int>> up(n + 2, vector<int>(MAXA));
        for (int c= 0; c < MAXA; ++c) {
            {
                int prev = -1;
                for (int i = 1; i <= n; ++i) {
                    up[i][c] = prev;
                    if (f[i][j] == c + 'a')
                        prev = i;
                }
            }
            {
                int prev = -1;
                for (int i = n; i >= 1; --i) {
                    int down = prev;
                    if (f[i][j] == c + 'a')
                        prev = i;
                    if (up[i][c] == -1)
                        up[i][c] = down;
                    else if (down == -1)
                        up[i][c] = up[i][c];
                    else
                        up[i][c] = i - up[i][c] < down - i ? up[i][c]  : down;
                    if (up[i][c] != -1)
                        ans[i].pb(up[i][c], c);
                }
            }
        }
        for (int i = 1; i <= n; ++i)
        {
            sort(ans[i].begin(), ans[i].end(), [i](const pii & p1, const pii & p2){
                    return abs(p1.ff - i) < abs(p2.ff - i);
            });
            if (!ans[i].empty()) {
                col[i][j].c1 = ans[i][0].ss, col[i][j].wc1 = ans[i][0].ff;
            }
            if (ans[i].size() >= 2)
                col[i][j].c2 = ans[i][1].ss, col[i][j].wc2 = ans[i][1].ff;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int x, y;
        cin >> x >> y;
        int mn = 1e9, wc1, wc2;
        if (row[x][y].c1 != col[x][y].c1 && row[x][y].c1 != -1 && col[x][y].c1 != -1) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[x][y].c1 - x);
            if (mn > pot)
                mn = pot;
        }
        if (row[x][y].c1 != col[x][y].c2 && row[x][y].c1 != -1 && -1 != col[x][y].c2) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[x][y].c2 - x);
            if (mn > pot)
                mn = pot;
        }
        if (row[x][y].c2 != col[x][y].c1 && row[x][y].c2 != -1 && -1 != col[x][y].c1) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[x][y].c1 - x);
            if (mn > pot)
                mn = pot;
        }
        if (row[x][y].c2 != col[x][y].c2 && row[x][y].c2 != -1 && -1 != col[x][y].c2) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[x][y].c2 - x);
            if (mn > pot)
                mn = pot;
        }
        if (mn == 1e9)
            cout << "-1\n";
        else {

        if (row[x][y].c1 != col[x][y].c1 && row[x][y].c1 != -1 && col[x][y].c1 != -1) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[x][y].c1 - x);
            if (mn == pot){cout << x << ' ' << row[x][y].wc1 << ' ' << col[x][y].wc1 << ' ' << y << '\n';continue;}
        }
        if (row[x][y].c1 != col[x][y].c2 && row[x][y].c1 != -1 && -1 != col[x][y].c2) {
            int pot = abs(row[x][y].wc1 - y) + abs(col[x][y].c2 - x);
            if (mn == pot){cout << x << ' ' << row[x][y].wc1 << ' ' << col[x][y].wc2 << ' ' << y << '\n';continue;}
        }
        if (row[x][y].c2 != col[x][y].c1 && row[x][y].c2 != -1 && -1 != col[x][y].c1) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[x][y].c1 - x);
            if (mn == pot){cout << x << ' ' << row[x][y].wc2 << ' ' << col[x][y].wc1 << ' ' << y << '\n';continue;}
        }
        if (row[x][y].c2 != col[x][y].c2 && row[x][y].c2 != -1 && -1 != col[x][y].c2) {
            int pot = abs(row[x][y].wc2 - y) + abs(col[x][y].c2 - x);
            if (mn == pot){cout << x << ' ' << row[x][y].wc2 << ' ' << col[x][y].wc2 << ' ' << y << '\n';continue;}
        }
        }
    }

    return 0;
}
