#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << ", ";
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
} init;

using std::endl;


bool div_in(ll l, ll r, ll n) {
    //cerr << "lrn " << l << ' ' << r << ' ' << n << std::endl;
    //cerr << ((r / n) * n >= l) << std::endl;
    return (r / n) * n >= l;
}


ll solve(ll a, ll n) {
    ll maxb = 62;
    ll ans = 0;
    for (int i = maxb; i >= 0; --i) {
        ans = (ans | (a & (1ll << i)));
        ll l = ans;
        ll r = (ans | ((1ll << (i)) - 1));
        if (!div_in(l, r, n))
            ans ^= (1ll << i);
    }
    //cerr << "ans " << ans << std::endl;
    return (a ^ ans);
}


int main() {
    int t;
    cin >> t;
    while (t--) {
        ll a, n;
        cin >> a >> n;
        cout << solve(a, n) << "\n";
    }
    return 0;
}
