#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

struct ev {
    int i, time;
    bool type;
    ev() {}
    ev(int _i, int _time, int _type) {
        i = _i;
        time = _time;
        type = _type;
    }
};

int n, m, k;
ev evs[(int)1e6];
int stime[(int)1e6];
int intime[(int)1e6];
int gdesidit[(int)1e6];
set <int> St;


bool cmp(ev x, ev y) {
    if (x.time != y.time)
        return x.time < y.time;
    else if (x.type != y.type)
        return x.type == false;
    else
        return x.i < y.i;
}

int main()
{
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int y, z;
        scanf("%d%d", &y, &z);
        evs[2 * i] = ev(i, y, true);
        evs[2 * i + 1] = ev(i, z, false);
    }
    sort(evs, evs + 2 * k, cmp);
    for (int i = 0; i < 2 *m - 1; i++)
        St.insert(i);
    for (int i = 0; i < 2 * k; i++) {
        if (evs[i].type == true) {
            int xxxx = *(St.begin());
            St.erase(St.begin());
            intime[xxxx] = evs[i].time;
            gdesidit[evs[i].i] = xxxx;
        }
        else {
            int xxxx = gdesidit[evs[i].i];
            St.insert(xxxx);
            stime[xxxx] += evs[i].time - intime[xxxx];
        }
    }
    int mina = 1e9, minb = 0;
    for (int i = m - 1; i <= 2*m - 2; i++) {
        if (stime[i] < mina)
            mina = stime[i];
        minb = i;
    }
    cout << mina << " " << minb + 1 - m + 1;
    return 0;
}
