#include <bits/stdc++.h>

using namespace std;

struct peppa
{
    int time, b;
    int tt, id;

    peppa() {};
};

bool operator < (const peppa &p1, const peppa &p2)
{
    if (p1.time != p2.time)
        return p1.time < p2.time;

    if (p1.tt != p2.tt)
        return p1.tt < p2.tt;

    return p1.id < p2.id;
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;

    vector< peppa > ev(2 * k);
    int a, b;

    for (int i = 0; i < k; i++)
    {
        cin >> a >> b;
        ev[2 * i].time = a; ev[2 * i].tt = 1; ev[2 * i].b = b;
        ev[2 * i + 1].time = b; ev[2 * i + 1].tt = -1;
        ev[2 * i].id = ev[2 * i + 1].id = i;
    }

    stable_sort(ev.begin(), ev.end());

    int lastMax = 0;
    int maxInd = 1;
    int time, tt;
    int currInd = 1;

    unordered_map<int, int> cc;

    for (auto ee : ev)
    {
        time = ee.time;
        tt = ee.tt;

        if (tt == -1 && cc[time] > 0)
        {
            currInd--;
            cc[time]--;
        }
        else if (tt == 1 && currInd < 2 * m)
        {
            cc[ee.b]++;
            currInd++;

            maxInd = max(maxInd, currInd);

            if (currInd == 2 * m)
                lastMax += ee.b - time;
        }
    }

    if (maxInd == 2 * m)
        cout << lastMax << ' ' << m;
    else if (maxInd <= m)
        cout << 0 << ' ' << 1;
    else
        cout << 0 << ' ' << maxInd - m + 1;

    return 0;
}
