#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0), cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;

    vector< vector<char> > F(n, vector<char>(m));

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> F[i][j];

    vector< vector<int> > l(26, vector<int>(n, -1)), r(26, vector<int>(n, -1)), u(26, vector<int>(m, -1)), d(26, vector<int>(m, -1));

    vector< vector< vector< pair<int, int> > > > nearestH(26);
    vector< vector< vector< pair<int, int> > > > nearestV(26);

    for (int i = 0; i < 26; i++)
    {
        nearestH[i] = vector< vector< pair<int, int> > >(n, vector< pair<int, int> >(m, {-1, -1}));
        nearestV[i] = vector< vector< pair<int, int> > >(n, vector< pair<int, int> >(m, {-1, -1}));
    }

    int ch, dist;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            ch = F[i][j] - 'a';

            for (int CH = 0; CH < 26; CH++)
            {
                dist = abs(nearestV[CH][i][j].first - i);

                if ((u[CH][j] != -1) && (nearestV[CH][i][j].first == -1 || dist > abs(u[CH][j] - i)))
                    nearestV[CH][i][j] = {u[CH][j], j};
            }

            u[ch][j] = i;
        }
    }

    for (int i = n - 1; i >= 0; i--)
    {
        for (int j = 0; j < m; j++)
        {
            ch = F[i][j] - 'a';

            for (int CH = 0; CH < 26; CH++)
            {
                dist = abs(nearestV[CH][i][j].first - i);

                if ((d[CH][j] != -1) && (nearestV[CH][i][j].first == -1 || dist > abs(d[CH][j] - i)))
                    nearestV[CH][i][j] = {d[CH][j], j};
            }

            d[ch][j] = i;
        }
    }

    for (int j = 0; j < m; j++)
    {
        for (int i = 0; i < n; i++)
        {
            ch = F[i][j] - 'a';

            for (int CH = 0; CH < 26; CH++)
            {
                dist = abs(nearestH[CH][i][j].second - j);

                if ((l[CH][i] != -1) && (nearestH[CH][i][j].second == -1 || dist > abs(l[CH][i] - j)))
                    nearestH[CH][i][j] = {i, l[CH][i]};
            }

            l[ch][i] = j;
        }
    }

    for (int j = m - 1; j >= 0; j--)
    {
        for (int i = 0; i < n; i++)
        {
            ch = F[i][j] - 'a';

            for (int CH = 0; CH < 26; CH++)
            {
                dist = abs(nearestH[CH][i][j].second - j);

                if ((r[CH][i] != -1) && (nearestH[CH][i][j].second == -1 || dist > abs(r[CH][i] - j)))
                    nearestH[CH][i][j] = {i, r[CH][i]};
            }

            r[ch][i] = j;
        }
    }

    int q;
    cin >> q;

    int ans;
    vector< pair<int, int> > cc(2);
    pair<int, int> p1, p2;

    int i, j;

    while (--q >= 0)
    {
        ans = 1e9;
        cin >> i >> j;
        i--; j--;


        for (int ch1 = 0; ch1 < 26; ch1++)
        {
            for (int ch2 = 0; ch2 < 26; ch2++)
            {
                if (ch1 == ch2)
                    continue;

                p1 = nearestH[ch1][i][j];
                p2 = nearestV[ch2][i][j];

                if (p1.first == -1 || p2.first == -1)
                    continue;

                dist = abs(p1.first - p2.first) + abs(p1.second - p2.second);

                if (dist < ans)
                {
                    ans = dist;
                    cc[0] = p1; cc[1] = p2;
                }
            }
        }

        if (ans == 1e9)
        {
            cout << -1 << '\n';
            continue;
        }

        cout << cc[0].first  + 1 << ' ' << cc[0].second + 1 << ' ' << cc[1].first + 1 << ' ' << cc[1].second + 1 << '\n';
    }

    return 0;
}
