#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));

	int a, b, c;
	cin >> a >> b >> c;

	if (a + b == c || a + c == b || b + c == a) {
		cout << 0;
		return 0;
	}

	int mn, mx, diff;

	//a
	mn = min(b, c), mx = max(b, c);
	diff = mx - mn;
	if (diff <= a) {
		if ((a - diff) % 2 == 0) {
			cout << 1 << '\n';
			cout << diff + (a - diff) / 2 << " " << (a - diff) / 2;
			return 0;
		}
	}

	//b
	mn = min(a, c), mx = max(a, c);
	diff = mx - mn;
	if (diff <= b) {
		if ((b - diff) % 2 == 0) {
			cout << 2 << '\n';
			cout << diff + (b - diff) / 2 << " " << (b - diff) / 2;
			return 0;
		}
	}

	//c
	mn = min(a, b), mx = max(a, b);
	diff = mx - mn;
	if (diff <= c) {
		if ((c - diff) % 2 == 0) {
			cout << 3 << '\n';
			cout << diff + (c - diff) / 2 << " " << (c - diff) / 2;
			return 0;
		}
	}

	cout << -1;

	return 0;
}