#include <iostream>
#include <cmath>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

struct Point
{
    int name, t, sit, cnts;
    bool up;

    Point(int name, int t, int cnts) : name(name), t(t), sit(0), up(false), cnts(cnts) {
    }
};

int n, m, k, fre = 0;
vector<Point> s;
set<int> sits, sits_up;
bool cmp(const Point &a, const Point &b) {
    if (a.name == b.name) {
        return a.t < b.t;
    }

    return a.name < b.name;
}

int main()
{
    scanf("%d%d%d", &n, &m, &k);

    for (int i = 0; i < k; i++)
    {
        int name1, name2, t;
        scanf("%d%d", &name1, &name2);
        s.push_back(Point(name1, 1, i));
        s.push_back(Point(name2, -1, i));
    }
    for (int i = 1; i < m; ++i)
        sits.insert(i);

    for (int i = 0; i < m; ++i)
        sits_up.insert(i);


    sort(s.begin(), s.end(), cmp);
    vector<int> beens(k + 1);
    vector<int> t(m), start(k + 1);
    vector<bool> check(k);

    for (auto x : s) {
        if (x.t == 1) {
            if (sits.size() == 0) {
                if (sits_up.size() != 0) {
                    beens[x.cnts] = *sits_up.begin() + 1;
                    check[x.cnts] = true;
                    start[x.cnts] = x.name;

                    sits_up.erase(sits_up.begin());
                }

                continue;
            }

            beens[x.cnts] = *sits.begin() + 1;
            start[x.cnts] = x.name;
            sits.erase(sits.begin());
        } else {
            if (beens[x.cnts] == 0)
                continue;

            if (check[x.cnts]) {
                t[beens[x.cnts] - 1] += x.name - start[x.cnts];
                sits_up.insert(beens[x.cnts] - 1);
            } else {
                sits.insert(beens[x.cnts] - 1);
            }
        }
    }


    int ans = 2e9, it;
    for (int i = 0; i < m; i++)
    {
        if (t[i] < ans)
        {
            ans = t[i];
            it = i + 1;
        }
    }
    printf("%d %d", ans, it);
    return 0;
}


/*
10 2 5
1 1000000000
2 5
2 5
3 9
7 10
*/

/*
10 2 3
1 10
3 9
7 10
*/
