#include <iostream>

using namespace std;


string conv(unsigned long long l) {
    string res(10, '0');
    for (int i = 0; i < 10; i++)
        res[i] = '0' + !!(l & (1 << (9 - i)));
    return res;
}

bool has_betw(unsigned long long l, unsigned long long r, unsigned long long q) {
    //cout << "in range " << l << ' ' << r << endl;
    return (((l - 1) / q + 1) * q <= r);
}


int main() {
    int Q;
    for (cin >> Q; Q > 0; Q--) {
        unsigned long long a, n, b = 0, cmask;
        cin >> a >> n;
        for (int i = 62; i >= 0; i--) {
            cmask = (1ll << i) - 1;
            //cout << "cmask " << cmask << endl;
            if (!has_betw((b ^ a) & (~cmask), (b ^ a) | cmask, n))
                b += (1ll << i);
        }
        cout << b << endl;
    }
    return 0;
}
