#include <iostream>

using namespace std;

/*
string conv(unsigned long long l) {
    string res(10, '0');
    for (int i = 0; i < 10; i++)
        res[i] = '0' + !!(l & (1 << (9 - i)));
    return res;
}
*/
bool has_betw(unsigned long long l, unsigned long long r, unsigned long long q) {
    //cout << "in range " << l << ' ' << r <<  ' ' << int((((l - 1) / q + 1) * q <= r)) << endl;
    return (((l - 1 + q) / q) * q <= r);
}

unsigned long long solve(unsigned long long a, unsigned long long n) {
    unsigned long long b = 0, cmask;
    for (int i = 62; i >= 0; i--) {
        cmask = (1ll << i) - 1;
        //cout << "cmask " << cmask << endl;
        if (!has_betw((b ^ a) & (~cmask), (b ^ a) | cmask, n))
            b += (1ll << i);
    }
    return b;
}

int main() {
    int Q;
    for (cin >> Q; Q > 0; Q--) {
        unsigned long long a, n, r;
        cin >> a >> n;
        //a = rand() % 128;
        //n = rand() % 128;
        r = solve(a, n);
        if ((a ^ r) % n != 0)
            cerr << a << ' ' << n << " %!=0" << endl;
        if (r > a) {
            cerr << a << ' ' << n << " r>a" << endl;
        }
        cout << r << endl;
    }
    return 0;
}
