#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long nd(long long x)
{
	long long ans = 1;
	for (int i = 2; x > 1; ++i)
	{
		if (x % i == 0)
		{
			long long s = 0;
			while (x % i == 0)
			{
				s++;
				x /= i;
			}
			ans *= (s + 1);
		}
	}
	return ans;
}

const long long dd = 6718464;

int fmain()
{
	long long x;
	cin >> x;

	long long k = x * 101 / dd / 100;
	long long ans = dd * k;
	if ((ans >= x) && (ans <= 1.01 * x))
	{
		cout << dd * k << endl;
		return 0;
	}

	for (long long i = x; 100 * i <= 101 * x; ++i)
	{
		if (nd(i) >= 100)
		{
			cout << i << endl;
			return 0;
		}
	}
	cout << -1 << endl;
	return 0;
}

int main()
{
	fmain();
	return 0;
}