#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const long long INF = 1e15 + 7;

long long bin_search(vector<long long> &d, long long v) {
	long long l = 0, r = d.size();
	while (r - l > 1) {
		long long m = (r + l) / 2;
		if (d[m] <= v) {
			l = m;
		}
		else {
			r = m;
		}
	}
	return l;
}

int main() {
	long long n, m, k;
	cin >> n >> k >> m;
	vector<long long> d(m);
	for (long long i = 0; i < m; i++) {
		cin >> d[i];
		//d[i]--;
	}
	sort(d.begin(), d.end());
	d.push_back(n + 1);
	vector< vector <long long> > dp(m + 1, vector<long long>(2, INF));

	dp[0][0] = 0;
	long long x = bin_search(d, d[0] + k - 1);
	dp[x][1] = min(INF, dp[0][0] + k);

	dp[0][1] = min(k, d[0]);
	for (long long i = 1; i < m; i++) {
		dp[i][0] = dp[i - 1][1];
		if (i == m - 1)
            x = m;
        else
            x = bin_search(d, d[i] + k - 1);
		dp[x][1] = min(dp[x][1], dp[i][0] + min(k, n - d[i] + 1));
	}
	cout << n - min(dp[m - 1][1], dp[m][1]);
	return 0;
}
