#include <iostream>
#include <algorithm>
#include <map>

using namespace std;

bool is_bad(long long n)
{
    long long prime = 0;
    long long cnt = 0;
    long long sum = 1;
    for (int i = 2; i * i <= n; ++i)
    {
        while (n % i == 0)
        {
            ++cnt;
            n /= i;
        }
        sum *= cnt + 1;
        cnt = 0;
    }
    if (n > 1)
    {
        sum *= 2;
    }
    return sum < 100;
}

int main()
{
    long long n;
    cin >> n;
    if (n >= 45360 * 100)
    {
        cout << ((n - 1) / 45360 + 1) * 45360 << endl;
        return 0;
    }
    long long i = n;
    while (is_bad(i) && i <= (n * 101) / 100)
    {
        ++i;
    }
    cout << (i <= (n * 101) / 100 ? i : -1) << endl;
    return 0;
}
