import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by orspc on 11.12.2016.
 */
public class Main {
    public void solve() throws IOException {
        long x = nextLong();
        if (x >= 5544000) {
            out.print(((x / 5544000) + 1) * 5544000);
        } else {
            int d[] = new int[5544000];
            for (int i = 0; i < 5544000; i++) d[i] = i;
            for (int i = 2; i <= Math.sqrt(5544000); i++) {
                if (d[i] == i) {
                    for (long j = i * i; j < 5544000; j += i) {
                        d[(int) j] = Math.min(d[(int) j], i);
                    }
                }
            }
            for (int i = (int) x; i <= (int) (x + (x / 100)); i++) {
                int s = 1, cnt = i, sh = 0;
                while (d[cnt] > 1) {
                    sh = 0;
                    int y = d[cnt];
                    while (cnt % y == 0) {
                        sh++;
                        cnt /= y;
                    }
                    s *= sh + 1;
                    if (s >= 100) {
                        out.print(i);

                        return;
                    }
                }
                if (s >= 100) {
                    out.print(i);

                    return;
                }
            }
            out.print(-1);
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }
}
