#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 4e5 + 100;

const int inf = 1e9 + 1;

int n, m;

vector<vector<int> > a;

vector<vector<int> > u[26], d[26], l[26], r[26];

int f(int xa, int ya, int xb, int yb){
    return abs(xa - xb) + abs(ya - yb);
}

char mas[(int) 5e5 + 1];

int main()
{
    #ifdef ONPC
    ifstream cin("a.in");
    ofstream cout("a.out");
    #endif
    ios::sync_with_stdio(0);
    scanf("%d%d", &n, &m);
    a.resize(n);
    for (int j = 0; j < n; j++)
        a[j].resize(m);
    for (int it = 0; it < 26; it++){
        u[it].resize(n);
        d[it].resize(n);
        l[it].resize(n);
        r[it].resize(n);
        for (int j = 0; j < n; j++)
            u[it][j].resize(m), d[it][j].resize(m), l[it][j].resize(m), r[it][j].resize(m);
    }
    for (int i = 0; i < n; i++)
    {
    scanf("%s", mas);
    for (int j = 0; j < m; j++){
        char c;
        a[i][j] = mas[j] - 'a';
    }
    }
    int last[26];
    for (int i = 0; i < n; i++){
        for (int it = 0; it < 26; it++)
            last[it] = -1;
        for (int j = 0; j < m; j++){
            for (int it = 0; it < 26; it++)
                l[it][i][j] = last[it];
            last[a[i][j]] = j;
        }
        for (int it = 0; it < 26; it++)
            last[it] = m;
        for (int j = m - 1; j >= 0; j--){
            for (int it = 0; it < 26; it++)
                r[it][i][j] = last[it];
            last[a[i][j]] = j;
        }
    }
    for (int i = 0; i < m; i++){
        for (int it = 0; it < 26; it++)
            last[it] = -1;
        for (int j = 0; j < n; j++){
            for (int it = 0; it < 26; it++)
                u[it][j][i] = last[it];
            last[a[j][i]] = j;
        }
        for (int it = 0; it < 26; it++)
            last[it] = n;
        for (int j = n - 1; j >= 0; j--){
            for (int it = 0; it < 26; it++)
                d[it][j][i] = last[it];
            last[a[j][i]] = j;
        }
    }
    int test;
    scanf("%d", &test);
    pair<int, int> xa, ya;
    pair<int, int> g, v;
    for (int iter = 0; iter < test; iter++){
        int x, y;
        scanf("%d%d", &x, &y);
        x--;
        y--;
        g = make_pair(-1, -1);
        v = make_pair(-1, -1);
        int ans = inf;
        for (int i = 0; i < 26; i++){
            if (l[i][x][y] >= 0 && (g.first == -1 || abs(y - g.first) > y - l[i][x][y])){
                if (g.second == -1 || a[x][g.first] != a[x][g.second])
                    g.second = g.first;
                g.first = l[i][x][y];
            }
            if (g.first != -1 && l[i][x][y] >= 0 && a[x][g.first] != a[x][l[i][x][y]] && (g.second == -1 || abs(y - g.second) > y - l[i][x][y]))
                g.second = l[i][x][y];

            if (r[i][x][y] < m && (g.first == -1 || abs(y - g.first) > -y + r[i][x][y])){
                if (g.second == -1 || a[x][g.first] != a[x][g.second])
                    g.second = g.first;
                g.first = r[i][x][y];
            }
            if (g.first != -1 && r[i][x][y] < m && a[x][g.first] != a[x][r[i][x][y]] && (g.second == -1 || abs(y - g.second) > -y + r[i][x][y]))
                g.second = r[i][x][y];

            if (u[i][x][y] >= 0 && (v.first == -1 || abs(x - v.first) > x - u[i][x][y])){
                if (v.second == -1 || a[v.first][y] != a[v.second][y])
                    v.second = v.first;
                v.first = u[i][x][y];
            }
            if (v.first != -1 && u[i][x][y] >= 0 && a[v.first][y] != a[u[i][x][y]][y] && (v.second == -1 || abs(x - v.second) > x - u[i][x][y]))
                v.second = u[i][x][y];
            if (d[i][x][y] < n && (v.first == -1 || abs(x - v.first) > -x + d[i][x][y])){
                if (v.second == -1 || a[v.first][y] != a[v.second][y])
                    v.second = v.first;
                v.first = d[i][x][y];
            }
            if (v.first != -1 && d[i][x][y] < n && a[v.first][y] != a[d[i][x][y]][y] && (v.second == -1 || abs(x - v.second) > -x + d[i][x][y]))
                v.second = d[i][x][y];
        }
        if (g.first != -1 && v.first != -1 && a[x][g.first] != a[v.first][y] && ans > f(x, g.first, v.first, y)){
            ans = f(x, g.first, v.first, y), xa = make_pair(x, g.first), ya = make_pair(v.first, y);
        }
        if (g.second != -1 && v.first != -1 && a[x][g.second] != a[v.first][y] && ans > f(x, g.second, v.first, y)){
            ans = f(x, g.second, v.first, y), xa = make_pair(x, g.second), ya = make_pair(v.first, y);
        }
        if (g.first != -1 && v.second != -1 && a[x][g.first] != a[v.second][y] && ans > f(x, g.first, v.second, y)){
            ans = f(x, g.first, v.second, y), xa = make_pair(x, g.first), ya = make_pair(v.second, y);
        }
        if (g.second != -1 && v.second != -1 && a[x][g.second] != a[v.second][y] && ans > f(x, g.second, v.second, y)){
            ans = f(x, g.second, v.second, y), xa = make_pair(x, g.second), ya = make_pair(v.second, y);
        }
        /*for (int i = 0; i < 26; i++)
            for (int j = 0; j < 26; j++)
                if (i != j){
                    if (l[i][x][y] >= 0 && u[j][x][y] >= 0 && ans > f(x, l[i][x][y], u[j][x][y], y))
                        ans = f(x, l[i][x][y], u[j][x][y], y), xa = make_pair(x, l[i][x][y]), ya = make_pair(u[j][x][y], y);
                    if (l[i][x][y] >= 0 && d[j][x][y] < n && ans > f(x, l[i][x][y], d[j][x][y], y))
                        ans = f(x, l[i][x][y], d[j][x][y], y), xa = make_pair(x, l[i][x][y]), ya = make_pair(d[j][x][y], y);
                    if (r[i][x][y] < m && d[j][x][y] < n && ans > f(x, r[i][x][y], d[j][x][y], y))
                        ans = f(x, r[i][x][y], d[j][x][y], y), xa = make_pair(x, r[i][x][y]), ya = make_pair(d[j][x][y], y);
                    if (r[i][x][y] < m && u[j][x][y] >= 0 && ans > f(x, r[i][x][y], u[j][x][y], y))
                        ans = f(x, r[i][x][y], u[j][x][y], y), xa = make_pair(x, r[i][x][y]), ya = make_pair(u[j][x][y], y);
                }
        */if (ans == inf)
            puts("-1");
            //cout << -1;
        else
            printf("%d %d %d %d\n", xa.first + 1, xa.second + 1, ya.first + 1, ya.second + 1);
    //        cout << xa.first + 1 << ' ' << xa.second + 1 << ' ' << ya.first + 1 << ' ' << ya.second + 1
    }
}
