#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<cstring>
#include<string>
#include<map>
#include<set>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define X first
#define Y second
#define psh push_back
#define all(a) a.begin(), a.end()

const int MAXN = (int)1e6 + 7;
const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7;

void file() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
}

int dp[MAXN];

int main() {
	file();
	int n, k, m;
	cin >> n >> k >> m;
	vector <int> a(m+2);
	for (int i = 1; i <= m; i++){
		cin >> a[i];
	}
	if (k == 1){
		cout << n - m << "\n";
		return 0;
	}
	a[m + 1] = a[m] + k - 1;
	sort(a.begin()+1, a.end());
	dp[0] = 0;
	for (int i = 1; i <= m+1; i++){
		int l = 0, r = i;
		while (r - l > 1){
			int mid = (l + r) / 2;
			//cout << mid << " " << a[i] << " " << a[mid] << "\n";
			if (a[i] - a[mid] + 1 <= k) r = mid;
			else l = mid;
		}
		//cout << l << "   a\n";
		if (l == 0){
			dp[i] = max(0, a[i] - k) + dp[0];
		}
		else{
			dp[i] = a[i] - a[l] - k + dp[l];
		}
		if (i == m) dp[m] += n - a[m];
		//cout << l << " " << dp[i] << "\n";
	}
	cout << max(dp[m], dp[m + 1]);
	return 0;
}