#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<cstring>
#include<string>
#include<map>
#include<set>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define X first
#define Y second
#define psh push_back
#define all(a) a.begin(), a.end()

const int MAXN = (int)1e6 + 7;
const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7;

void file() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
}

struct pr {
	int l, r, u, d;

	pr() {
		l = r = u = d = -1;
	}
};

int n, m;

bool nice(int i, int j) {
	return (i >= 0) && (j >= 0) && (i < n) && (j < m);
}




int main() {
	file();
	cin >> n >> m;
	vector<vector<char>> a(n);
	vector<vector<pr>> b(n);
	forn(i, n) {
		a[i].resize(m);
		b[i].resize(m);
		forn(j, m) {
			cin >> a[i][j];
		}
	}
	forn(i, n) {
		int kol = 0;
		char tek = '#';
		for (int j = 0; j < m - 1; ++j) {
			if (tek != a[i][j]) {
				tek = a[i][j];
				kol = 1;
			} else {
				++kol;
			}
			b[i][j + 1].l = kol;
		}
		kol = 0;
		tek = '#';
		for (int j = m - 1; j >= 1; --j) {
			if (tek != a[i][j]) {
				tek = a[i][j];
				kol = 1;
			}
			else {
				++kol;
			}
			b[i][j - 1].r = kol;
		}
	}
	forn(j, m) {
		int kol = 0;
		char tek = '#';
		for (int i = 0; i < n - 1; ++i) {
			if (tek != a[i][j]) {
				tek = a[i][j];
				kol = 1;
			}
			else {
				++kol;
			}
			b[i + 1][j].u = kol;
		}
		kol = 0;
		tek = '#';
		for (int i = n - 1; i >= 1; --i) {
			if (tek != a[i][j]) {
				tek = a[i][j];
				kol = 1;
			}
			else {
				++kol;
			}
			b[i - 1][j].d = kol;
		}
	}
	int q;
	cin >> q;
	forn(w, q) {
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		char l = 0, r = 1, u = 2, d = 3;
		set<char> s;
		vector<pair<pair<char, int>, int>> vh, vv;
		vector<pair<pair<char, int>, int>> bvh, bvv;
		bool f = 0;
		int lk = -1, rk = -1, uk = -1, dk = -1;
		if (nice(x - 1, y)) {
			u = a[x - 1][y];
			uk = b[x][y].u;
			if (x - uk > 0) {
				f = 1;
				bvh.psh({ { u, uk }, 0 });
			}
			s.insert(u);
			vh.psh({ { u, uk }, 0});
		}
		if (nice(x + 1, y)) {
			d = a[x + 1][y];
			dk = b[x][y].d;
			if (x + dk < n - 1) {
				f = 1;
				bvh.psh({ { d, dk }, 1 });
			}
			s.insert(d);
			vh.psh({ { d, dk }, 1 });
		}
		if (nice(x, y + 1)) {
			r = a[x][y + 1];
			rk = b[x][y].r;
			if (y + rk < m - 1) {
				f = 1;
				bvv.psh({ { r, rk }, 1 });
			}
			s.insert(r);
			vv.psh({ { r, rk }, 1 });
		}
		if (nice(x, y - 1)) {
			l = a[x][y - 1];
			lk = b[x][y].l;
			if (y - lk > 0) {
				f = 1;
				bvv.psh({ { l, lk }, 0 });
			}
			s.insert(l);
			vv.psh({ { l, lk }, 0 });
		}
		if (s.size() == 0 || s.size() == 1 && !f) {
			cout << -1 << "\n";
			continue;
		}
		if (vh.size() == 0 || vv.size() == 0) {
			cout << -1 << "\n";
			continue;
		}
		sort(all(vh));
		sort(all(vv));
		sort(all(bvh));
		sort(all(bvv));
		int ans = INF;
		int ansx, ansy;
		for (auto xx : vh) {
			for (auto yy : vv) {
				if (xx.X.X == yy.X.X) {
					int tekans = min(xx.X.Y, yy.X.Y) + 2;
					if (xx.X.Y < yy.X.Y) {
						if (tekans < ans) {
							ans = tekans;
							if (xx.Y == 0) {
								ansx = x - xx.X.Y - 1;
							}
							else {
								ansx = x + xx.X.Y + 1;
							}
							if (yy.Y == 0) {
								ansy = y - 1;
							}
							else {
								ansy = y + 1;
							}
						}
					}
					else {
						if (tekans < ans) {
							ans = tekans;
							if (xx.Y == 0) {
								ansx = x - 1;
							}
							else {
								ansx = x + 1;
							}
							if (yy.Y == 0) {
								ansy = y - yy.X.Y - 1;
							}
							else {
								ansy = y + yy.X.Y + 1;
							}
						}
					}
					
				}
				else {
					int tekans = 2;
					if (tekans < ans) {
						ans = tekans;
						if (xx.Y == 0) {
							ansx = x - 1;
						}
						else {
							ansx = x + 1;
						}
						if (yy.Y == 0) {
							ansy = y - 1;
						}
						else {
							ansy = y + 1;
						}
					}
				}
			}
		}
		cout << x + 1 << " " << ansy + 1 << " " << ansx + 1 << " " << y + 1 << "\n";
	}
	
	return 0;
}