#include <bits/stdc++.h>
using namespace std;

vector<int> z_function(string s, string t){
    s = s+"#"+t;
    int l = 0, r = 0;
    int n = (int) s.size();
    vector<int> z(n, 0);
    for(int i = 1; i < n; i++){
        if(i <= r) z[i] = min(r-i+1, i-l+1);
        while(i+z[i] < n && s[z[i]] == s[i+z[i]]) z[i]++;
        if(i+z[i] >= r) r = i+z[i], l = i;
    }
    return vector<int> (z.begin()+s.size()+1, z.end());
}

const int maxn = 1e5;

vector< vector<int> > g[maxn], d[maxn];
set<int> undone;
vector< unordered_set<int> > zs;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    int ans = 0;
    for(int i = 0; i < n; i++){
        char type;
        cin >> type;
        string s;
        cin >> s;
        int l = (int) s.size();
        s = s+s;
        s = s.substr(ans%l, l);
        ans = 0;
        if(type == '+'){
            g.push_back(s);
            set<int> to_delete;
            for(int j : undone){
                vector<int> z = z_function(s, d[i]);
                for(size_t k = 0; k < z.size(); k++)
                    if(z[k] == l)
                        zs[j][k].push_back(l);
                m = (int) d[j].size();
                vector<bool> dp(m+1, false);
                dp[m] = true;
                for(int j = m-1; j >= 0; j--)
                    for(int c : zs[j])
                        if(dp[j+c])
                            dp[j] = true;
                if(dp[0]) to_delete.push_back(j), ans++;
            }
            for(int x : to_delete) undone.erase(x);
        }
        else{
            zs[d.size()].resize(l);
            for(size_t j = 0; j < g.size(); j++){
                vector<int> z = z_function(g[j], s);
                for(size_t k = 0; k < z.size(); k++)
                    if(z[k] == l)
                        zs[j][k].push_back(l);
                m = (int) d[j].size();
                vector<bool> dp(m+1, false);
                dp[m] = true;
                for(int j = m-1; j >= 0; j--)
                    for(int c : zs[j])
                        if(dp[j+c])
                            dp[j] = true;
                if(dp[0]) to_delete.push_back(j), ans++;
            }
            for(int x : to_delete) undone.erase(x);
        }
    }

    return 0;
}
