#include <bits/stdc++.h>
using namespace std;
#define int long long
const int maxn = 5e3, len = 1e6;

int a[maxn][maxn];
int c[maxn], r[maxn];
int _c[maxn], _r[maxn];
int q[len][4];

long long p17[maxn], p19[maxn];

//int dbg[10][10];

main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    for(int i = 0; i < maxn; i++)
        r[i] = c[i] = _r[i] = _c[i] = i;

    int h, w, n;
    cin >> h >> w >> n;

    for(int i = 0; i < h; i++)
        for(int j = 0; j < w; j++)
            a[i][j] = i*w+j;

    string s;
    cin >> s;

    int k[4];
    for(int i = 0; i < 4; i++){
        cin >> k[i];
        for(int j = 0; j < k[i]; j++)
            cin >> q[j][i];
        int mod = (i&2==0) ? h : w;
        for(int j = k[i]; j < n; j++)
            q[j][i] = (10007ll*q[j-2][i] + 10009ll*q[j-1][i] + 87277ll) % mod;
    }

    for(int i = 0; i < n; i++){
        char ch = s[i];
        if(ch == 'c'){
            int x = q[i][1], y = q[i][3];
            swap(c[x], c[y]);
            //swap(_c[x], _c[y]);
        }
        else if(ch == 'r'){
            int x = q[i][0], y = q[i][2];
            swap(r[x], r[y]);
            //swap(_r[x], _r[y]);
        }
        else{
            int x = q[i][0], y = q[i][1];
            int _x = q[i][2], _y = q[i][3];
            swap(a[r[x]][c[y]], a[r[_x]][c[_y]]);
        }
        /*
        for(int i = 0; i < h; i++){
            for(int j = 0; j < w; j++){
                int x = r[i], y = c[j];
                dbg[x][y] = a[i][j];
            }
        }
        for(int i = 0; i < h; i++){
            for(int j = 0; j < w; j++)
                cout << dbg[i][j] << " ";
            cout << endl;
        }
        cout << endl;
        */
    }

    p17[0] = p19[0] = 1;

    const int mod = 1e9+7;

    for(int i = 1; i < maxn; i++){
        p17[i] = 17ll*p17[i-1] % mod;
        p19[i] = 19ll*p19[i-1] % mod;
    }

    long long ans = 0;

    for(int i = 0; i < h; i++){
        for(int j = 0; j < w; j++){
            int x = r[i], y = c[j];
            ans += 1ll*a[x][y]*p17[i]%mod*p19[j]%mod;
            ans %= mod;
            //cerr << a[i][j] << " " << p17[x] << " " << p19[y] << endl;
        }
    }

    cout << ans;

    return 0;
}
