#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

struct ev{
	int x, ind, type, x2;
};

bool comp(ev a, ev b){
	if (a.x != b.x){
		return a.x < b.x;
	}
	if (a.type != b.type){
		return a.type > b.type;
	}
	return a.ind < b.ind;
}

int main(){
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);
	vector <ev> eve(2 * k);
	int co = 0;
	for (int i = 0; i < 2 * k; i += 2){
		int a, b;
		scanf("%d %d", &a, &b);
		eve[i].x = a;
		eve[i].type = 0;
		eve[i].ind = co;
		eve[i].x2 = b;
		eve[i + 1].x = b;
		eve[i + 1].ind = co;
		eve[i + 1].type = 1;
		co++;
	}
	sort(eve.begin(), eve.end(), comp);
	int bal = 0;
	set <pair<int, int>> s1;
	set <pair<int, int>> s2;
	for (int i = 0; i < m; i++){
		pair <int, int> temp;
		temp.first = 0;
		temp.second = i;
		s1.insert(temp);
		s2.insert(temp);
	}
	vector <int> sits(m, 0);
	for (int i = 0; i < 2 * k; i++){
		if (eve[i].type == 0){
			bal++;
			if (bal <= m - 1){
				pair <int, int> t;
				t.first = eve[i].x2;
				t.second = s1.begin()->second;
				s1.erase(s1.begin());
				s1.insert(t);
			}
			else if ((bal > m - 1) && (bal - m < m)){
				sits[s2.begin()->second] += eve[i].x2 - eve[i].x;
				pair <int, int> t;
				t.first = eve[i].x2;
				t.second = s2.begin()->second;
				s2.erase(s2.begin());
				s2.insert(t);
				
			}
			else if (!(bal - m < m)){
				bal--;
			}
		}
		else if (eve[i].type == 1){
			bal--;
			if (s1.begin()->first < s2.begin()->first){
				pair <int, int> t;
				t.first = 0;
				t.second = s1.begin()->second;
				s1.erase(s1.begin());
				s1.insert(t);
			}
			else{
				s2.erase(s2.begin());
				pair <int, int> t;
				t.first = 0;
				t.second = s2.begin()->second;
				s2.insert(t);
			}
		}
	}
	int mini = 1000000001, minind = -1;
	for (int i = 0; i < m; i++){
		if (mini > sits[i]){
			mini = sits[i];
			minind = i + 1;
		}
	}
	cout << mini << ' ' << minind;
	return 0;
}