#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

const double EPS = 1e-9;
typedef long long ll;
const int sz = 1e6;
const int INF = 1e9;

struct eve {
	int stop;
	int pas;
	int st;
	bool operator< (eve arg) {
		return stop < arg.stop || (stop == arg.stop && pas < arg.pas);
	}
	eve() {
		stop = 0;
		pas = 0;
		st = 0;
	}
	eve(int a, int b, int c) {
		stop = a;
		pas = b;
		st = c;
	}
};

int a[sz], b[sz];
vector <eve> line;
int place[sz];
bool ban[sz];

int main() {
#ifdef MINE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);
	for (int i = 0; i < k; i++) {
		scanf("%d%d", &a[i], &b[i]);
		line.push_back(eve(a[i], i, 1));
		line.push_back(eve(b[i], i, -1));
	}
	sort(line.begin(), line.end());
	int mmax = 0, balance = 0, res = 0, time = 1, human = -1;
	for (int i = 0; i < line.size(); i++) {
		if (!ban[line[i].pas]){
			if (line[i].pas == human) {
				res += line[i].stop - time;
				human = -1;
			}
			balance += line[i].st;
			if (balance == 2 * m - 1 && human == -1) {
				time = line[i].stop;
				human = line[i].pas;
			}
		}
		if (balance == 2 * m) {
			ban[line[i].pas] = true;
			balance--;
		}
		mmax = max(mmax, balance);
	}
	if (mmax < 2 * m - 1) {
		cout << "0 " << min(mmax + 1, m);
	}
	cout << res << " " << m;
	return 0;
}