#include <iostream>
#include <vector>

using namespace std;

void cinarray(vector<long long>& v, int n, int mod) {
    int k;
    cin >> k;
    for (int i = 0; i < k; i++)
        cin >> v[i];
    for (int i = k; i < n; i++)
        v[i] = (10007 * v[i - 2] + 10009 * v[i - 1] + 87277) % mod;
}

int main() {
    long long mod = int(1e9) + 7;
    int h, w, n;
    cin >> h >> w >> n;
    vector<long long> p17(h + 1);
    p17[0] = 1;
    for (int i = 1; i <= h; i++) p17[i] = (p17[i - 1] * 17) % mod;
    vector<long long> p19(w + 1);
    p19[0] = 1;
    for (int i = 1; i <= w; i++) p19[i] = (p19[i - 1] * 19) % mod;
    vector<long long> A(n), B(n), C(n), D(n);
    string s;
    cin >> s;
    cinarray(A, n, h);
    cinarray(B, n, w);
    cinarray(A, n, h);
    cinarray(D, n, w);
    vector<vector<long long>> t(h, vector<long long>(w, 0));
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            t[i][j] = w * i + j;
    vector<int> r(h), c(w);
    for (int i = 0; i < h; i++) r[i] = i;
    for (int j = 0; j < w; j++) c[j] = j;
    for (int i = 0; i < h; i++) {
        if (s[i] == 'c')
            swap(c[B[i]], c[D[i]]);
        else if (s[i] == 'r')
            swap(r[A[i]], r[C[i]]);
        else
            swap(t[A[i]][B[i]], t[C[i]][D[i]]);
    }
    long long cs = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cs += (((t[r[i]][c[j]] * p17[i]) % mod) * p19[j]) % mod;
        }
    }
    cout << cs << endl;
}
