#include <bits/stdc++.h>

//#define int long long
#define pb push_back
#define len(a) (int)((a).size())
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define f first
#define s second
#define all(a) (a).begin(), (a).end()

using namespace std;

vector<int> t;

struct Event {
    int t, x, id;
    Event(int t, int x, int id) : t(t), x(x), id(id) {}
    Event() = default;
    bool operator<(Event a) const {
        return x < a.x || x == a.x && t < a.t && x == a.x && t == a.t && id < a.id;
    }
};

void update(int v, int l, int r, int i, int add) {
    if (i >= r || i < l) return;
    if (l == r - 1) {
        t[v] += add;
        return;
    }
    update(2 * v, l, (r + l) / 2, i, add);
    update(2 * v + 1, (r + l) / 2, r, i, add);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get(int v, int l, int r) {
    if (t[v] == r - l) return -1;
    if (l == r - 1 && t[v] == 0) return l;
    int g = get(2 * v, l, (r + l) / 2);
    if (g != -1) return g;
    return get(2 * v + 1, (r + l) / 2, r);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("b.in", "r", stdin);
    int n, m, k;
    cin >> n >> m >> k;
    t.resize(4 * m, 0);
    vector<Event> q;
    vector<pair<int, int> > p;
    forn(i, k) {
        int a, b;
        cin >> a >> b;
        q.pb({-1, a, i});
        q.pb({1, b, i});
        p.pb({a, b});
    }
    q.pb({-1, 0, -1});
    sort(all(q));
    int m1 = 0;
    vector<int> used(k, -1);
    vector<int> time(k, 0);
    forn(i, len(q)) {
        //cout << i << ' ' << q[i].t << ' ' << q[i].x << ' ' << q[i].id << endl;
        if (q[i].t == -1) {
            if (m1 < m) {
                m1++;
            }
            else {
                int x1 = get(1, 0, m);
                if (x1 != -1) {
                    update(1, 0, m, x1, 1);
                    used[q[i].id] = x1;
                }
                else {
                    used[q[i].id] = -2;
                }
            }
        }
        else {

            if (used[q[i].id] == -1) {
                m1--;
            }
            else if (used[q[i].id] != -2) {
                //cout << "aaaaa" << endl;
                //cout << q[i].id << endl;
                time[used[q[i].id]] += p[q[i].id].s - p[q[i].id].f;
                update(1, 0, m, used[q[i].id], -1);
            }
        }
    }
    int mi = n, ans;
    forn(i, m) {
        if (time[i] < mi) {
            mi = time[i];
            ans = i;
        }
    }
    cout << mi << ' ' << ans + 1;
    return 0;
}
