//#include <bits/stdc++.h>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <set>

using namespace std;

#define ll long long

const int maxN = 1000005;
const int INF = 1e9;

char arr[maxN];
int dpL[maxN][26];
int dpR[maxN][26];
int dpU[maxN][26];
int dpD[maxN][26];

int dpUt[26];
int dpDt[26];
int dpUt2[26];
int dpDt2[26];

void build(int n, int m)
{
    for(int y = 0; y < n; y++)
    {
        for(int x = 0; x < m; x++)
        {
            for(int c = 0; c < 26; c++)
            {
                if(arr[y*m + x] == c) dpU[y*m + x][c] = y;
                else dpU[y*m + x][c] = (y > 0 ? dpU[(y-1)*m + x][c] : -1);
            }
        }
    }

    for(int y = n - 1; y >= 0; y--)
    {
        for(int x = 0; x < m; x++)
        {
            for(int c = 0; c < 26; c++)
            {
                if(arr[y*m + x] == c) dpD[y*m + x][c] = y;
                else dpD[y*m + x][c] = (y < n - 1 ? dpD[(y+1)*m + x][c] : -1);
            }
        }
    }

    for(int x = 0; x < m; x++)
    {
        for(int y = 0; y < n; y++)
        {
            for(int c = 0; c < 26; c++)
            {
                if(arr[y*m + x] == c) dpL[y*m + x][c] = x;
                else dpL[y*m + x][c] = (x > 0 ? dpL[y*m + x - 1][c] : -1);
            }
        }
    }

    for(int x = m - 1; x >= 0; x--)
    {
        for(int y = 0; y < n; y++)
        {
            for(int c = 0; c < 26; c++)
            {
                if(arr[y*m + x] == c) dpR[y*m + x][c] = x;
                else dpR[y*m + x][c] = (x < m - 1 ? dpR[y*m + x + 1][c] : -1);
            }
        }
    }

}


int main()
{
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    for(int y = 0; y < n; y++)
    {
        string str;
        cin >> str;

        for(int x = 0; x < m; x++) arr[y*m + x] = str[x] - 'a';
    }

    build(n, m);

    /*for(int y = 0; y < n; y++)
    {
        for(int x = 0; x < m; x++)
        {
            cout << dpU[y*m + x][0] << " ";
        }
        cout << endl;
    }*/

    int q;
    cin >> q;

    while(q--)
    {
        int x, y;
        cin >> y >> x;
        x--; y--;

        for(int c = 0; c < 26; c++) dpUt[c] = dpDt[c] = -1;
        for(int c = 0; c < 26; c++) dpUt2[c] = dpDt2[c] = -1;

        for(int c = 1; c < 26; c++)
        {
            if(y > 0 && dpU[(y - 1)*m + x][c - 1] != -1) dpUt[c] = max(dpUt[c-1], dpU[(y - 1)*m + x][c - 1]);
            else dpUt[c] = dpUt[c-1];
            if(y < n - 1 && dpD[(y + 1)*m + x][c - 1] != -1)
            {
                if(dpDt[c - 1] == -1) dpDt[c] = dpD[(y + 1)*m + x][c - 1];
                else dpDt[c] = min(dpDt[c - 1], dpD[(y + 1)*m + x][c - 1]);
            }
            else dpDt[c] = dpDt[c-1];
        }

        for(int c = 24; c >= 0; c--)
        {
            if(y > 0 && dpU[(y - 1)*m + x][c + 1] != -1) dpUt2[c] = max(dpUt2[c+1], dpU[(y - 1)*m + x][c + 1]);
            else dpUt2[c] = dpUt2[c+1];
            if(y < n - 1 && dpD[(y + 1)*m + x][c + 1] != -1)
            {
                if(dpDt2[c + 1] == -1) dpDt2[c] = dpD[(y + 1)*m + x][c + 1];
                else dpDt2[c] = min(dpDt2[c + 1], dpD[(y + 1)*m + x][c + 1]);
            }
            else dpDt2[c] = dpDt2[c+1];
        }

        for(int c = 0; c < 26; c++)
        {
            dpUt[c] = max(dpUt[c], dpUt2[c]);
            if(dpDt2[c] != -1 && dpDt[c] != -1) dpDt[c] = min(dpDt[c], dpDt2[c]);
            else dpDt[c] = max(dpDt[c], dpDt2[c]);
        }

        int ans = INF;
        pair<int, int> p1, p2;
        for(int c1 = 0; c1 < 26; c1++)
        {
            int l1 = INF, l2 = INF;
            if(x > 0 && dpL[y*m + x - 1][c1] != -1) l1 = min(l1, x - dpL[y*m + x - 1][c1]);
            if(x < m - 1 && dpR[y*m + x + 1][c1] != -1) l1 = min(l1, dpR[y*m + x + 1][c1] - x);

            if(dpUt[c1] != -1) l2 = min(l2, y - dpUt[c1]);
            if(dpDt[c1] != -1) l2 = min(l2, dpDt[c1] - y);

            if(ans > l1 + l2)
            {
                ans = l1 + l2;
                if(x > 0 && dpL[y*m + x - 1][c1] != -1 && l1 == x - dpL[y*m + x - 1][c1]) p1 = make_pair(x - l1, y);
                else p1 = make_pair(x + l1, y);

                if(dpUt[c1] != -1 && l2 == y - dpUt[c1]) p2 = make_pair(x, y - l2);
                else p2 = make_pair(x, y + l2);
            }
        }
        if(ans == INF) cout << "-1\n";
        else cout << p1.second + 1 << " " << p1.first + 1 << " " << p2.second + 1 << " " << p2.first + 1 << "\n";
    }




    return 0;
}
