#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <ctime>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
     
typedef int ll;
     
const ll INF = (ll)1e9;
 
int main(void) {
    ll n, m;
    scanf("%d%d\n", &n, &m);
    char** a = new char*[n];
    for (ll i = 0; i < n; ++i) {
        a[i] = new char[m];
    }
    int*** l = new int**[n];
    int*** r = new int**[n];
    int*** u = new int**[n];
    int*** d = new int**[n];
    for (ll i = 0; i < n; ++i) {
        l[i] = new int*[m];
        r[i] = new int*[m];
        u[i] = new int*[m];
        d[i] = new int*[m];
        for (ll j = 0; j < m; ++j) {
            l[i][j] = new int[26];
            r[i][j] = new int[26];
            u[i][j] = new int[26];
            d[i][j] = new int[26];
            for (ll k = 0; k < 26; ++k) {
                l[i][j][k] = INF;
                r[i][j][k] = INF;
                u[i][j][k] = INF;
                d[i][j][k] = INF;
            }
        }
    }
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            scanf("%c", &a[i][j]);
        }
        if (i != n - 1) {
            scanf("\n");
        }
    }
    for (ll i = 0; i < n; ++i) {
        std::vector<ll> cur(26, INF);
        for (ll j = 0; j < m; ++j) {
            for (ll k = 0; k < 26; ++k) {
                l[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = j;
        }
        cur.assign(26, INF);
        for (ll j = m - 1; j >= 0; --j) {
            for (ll k = 0; k < 26; ++k) {
                r[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = j;
        }
    }
    for (ll j = 0; j < m; ++j) {
        std::vector<ll> cur(26, INF);
        for (ll i = 0; i < n; ++i) {
            for (ll k = 0; k < 26; ++k) {
                u[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = i;
        }
        cur.assign(26, INF);
        for (ll i = n - 1; i >= 0; --i) {
            for (ll k = 0; k < 26; ++k) {
                d[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = i;
        }
    }
    ll q;
    scanf("%d", &q);
    for (ll it = 0; it < q; ++it) {
        ll i, j;
        scanf("%d%d", &i, &j);
        --i, --j;
        ll answer = INF, i1, j1, i2, j2;
        for (ll c1 = 0; c1 < 26; ++c1) {
            for (ll c2 = 0; c2 < 26; ++c2) {
                if (c1 != c2) {
                    if (abs(l[i][j][c1] - j) + abs(u[i][j][c2] - i) < answer && l[i][j][c1] != INF && u[i][j][c2] != INF) {
                        answer = abs(l[i][j][c1] - j) + abs(u[i][j][c2] - i);
                        i1 = i, j1 = l[i][j][c1], i2 = u[i][j][c2], j2 = j;
                    }
                    if (abs(l[i][j][c1] - j) + abs(d[i][j][c2] - i) < answer && l[i][j][c1] != INF && d[i][j][c2] != INF) {
                        answer = abs(l[i][j][c1] - j) + abs(d[i][j][c2] - i);
                        i1 = i, j1 = l[i][j][c1], i2 = d[i][j][c2], j2 = j;
                    }
                    if (abs(r[i][j][c1] - j) + abs(u[i][j][c2] - i) < answer && r[i][j][c1] != INF && u[i][j][c2] != INF) {
                        answer = abs(r[i][j][c1] - j) + abs(u[i][j][c2] - i);
                        i1 = i, j1 = r[i][j][c1], i2 = u[i][j][c2], j2 = j;
                    }
                    if (abs(r[i][j][c1] - j) + abs(d[i][j][c2] - i) < answer && r[i][j][c1] != INF && d[i][j][c2] != INF) {
                        answer = abs(r[i][j][c1] - j) + abs(d[i][j][c2] - i);
                        i1 = i, j1 = r[i][j][c1], i2 = d[i][j][c2], j2 = j;
                    }
                }
            }
        }
        if (answer == INF) {
            printf("-1\n");
        } else {
            printf("%d %d %d %d\n", i1 + 1, j1 + 1, i2 + 1, j2 + 1);
        }
    }
    return 0;
}