#include <stdio.h>
#include <math.h>
      
const int INF = (int)1e9;
  
int main(void) {
    int n, m;
    scanf("%d%d\n", &n, &m);
    char** a = new char*[n];
    for (int i = 0; i < n; ++i) {
        a[i] = new char[m];
    }
    int*** l = new int**[n];
    int*** r = new int**[n];
    int*** u = new int**[n];
    int*** d = new int**[n];
    for (int i = 0; i < n; ++i) {
        l[i] = new int*[m];
        r[i] = new int*[m];
        u[i] = new int*[m];
        d[i] = new int*[m];
        for (int j = 0; j < m; ++j) {
            l[i][j] = new int[26];
            r[i][j] = new int[26];
            u[i][j] = new int[26];
            d[i][j] = new int[26];
            for (int k = 0; k < 26; ++k) {
                l[i][j][k] = INF;
                r[i][j][k] = INF;
                u[i][j][k] = INF;
                d[i][j][k] = INF;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            scanf("%c", &a[i][j]);
        }
        if (i != n - 1) {
            scanf("\n");
        }
    }
    for (int i = 0; i < n; ++i) {
        int cur[26];
        for (int j = 0; j < 26; ++j) {
            cur[j] = INF;
        }
        for (int j = 0; j < m; ++j) {
            for (int k = 0; k < 26; ++k) {
                l[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = j;
        }
        for (int j = 0; j < 26; ++j) {
            cur[j] = INF;
        }
        for (int j = m - 1; j >= 0; --j) {
            for (int k = 0; k < 26; ++k) {
                r[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = j;
        }
    }
    for (int j = 0; j < m; ++j) {
        int cur[26];
        for (int j = 0; j < 26; ++j) {
            cur[j] = INF;
        }
        for (int i = 0; i < n; ++i) {
            for (int k = 0; k < 26; ++k) {
                u[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = i;
        }
        for (int j = 0; j < 26; ++j) {
            cur[j] = INF;
        }
        for (int i = n - 1; i >= 0; --i) {
            for (int k = 0; k < 26; ++k) {
                d[i][j][k] = cur[k];
            }
            cur[a[i][j] - 'a'] = i;
        }
    }
    int q;
    scanf("%d", &q);
    for (int it = 0; it < q; ++it) {
        int i, j;
        scanf("%d%d", &i, &j);
        --i, --j;
        int answer = INF, i1, j1, i2, j2;
        for (int c1 = 0; c1 < 26; ++c1) {
            for (int c2 = 0; c2 < 26; ++c2) {
                if (c1 != c2) {
                    if (abs(l[i][j][c1] - j) + abs(u[i][j][c2] - i) < answer && l[i][j][c1] != INF && u[i][j][c2] != INF) {
                        answer = abs(l[i][j][c1] - j) + abs(u[i][j][c2] - i);
                        i1 = i, j1 = l[i][j][c1], i2 = u[i][j][c2], j2 = j;
                    }
                    if (abs(l[i][j][c1] - j) + abs(d[i][j][c2] - i) < answer && l[i][j][c1] != INF && d[i][j][c2] != INF) {
                        answer = abs(l[i][j][c1] - j) + abs(d[i][j][c2] - i);
                        i1 = i, j1 = l[i][j][c1], i2 = d[i][j][c2], j2 = j;
                    }
                    if (abs(r[i][j][c1] - j) + abs(u[i][j][c2] - i) < answer && r[i][j][c1] != INF && u[i][j][c2] != INF) {
                        answer = abs(r[i][j][c1] - j) + abs(u[i][j][c2] - i);
                        i1 = i, j1 = r[i][j][c1], i2 = u[i][j][c2], j2 = j;
                    }
                    if (abs(r[i][j][c1] - j) + abs(d[i][j][c2] - i) < answer && r[i][j][c1] != INF && d[i][j][c2] != INF) {
                        answer = abs(r[i][j][c1] - j) + abs(d[i][j][c2] - i);
                        i1 = i, j1 = r[i][j][c1], i2 = d[i][j][c2], j2 = j;
                    }
                }
            }
        }
        if (answer == INF) {
            printf("-1\n");
        } else {
            printf("%d %d %d %d\n", i1 + 1, j1 + 1, i2 + 1, j2 + 1);
        }
    }
    return 0;
}