#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <ctime>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
     
typedef long long ll;
     
const ll INF = (ll)1e18;
     
ll div(ll n) {
    std::map<ll, ll> f;
    for (ll i = 2; i * i <= n; ++i) {
        while (n % i == 0) {
            ++f[i];
            n /= i;
        }
    }
    if (n > 1) {
        ++f[n];
    }
    ll res = 1;
    for (auto it: f) {
        res *= it.second + 1;
    }
    return res;
}
 
int main(void) {
    ll n;
    scanf("%lld", &n);
    ll cur = 2 * 3 * 5 * 7 * 11 * 13 * 17;
    ll first = n, second = n + n / 100;
    if (div(first) >= 100) {
        printf("%lld\n", first);
        return 0;
    } else if (div(second) >= 100) {
        printf("%lld\n", second);
        return 0;
    }
    ll step = sqrt(second - first);
    for (ll i = first + 1; i < second; i += step) {
        if (div(i) >= 100) {
            printf("%lld\n", i);
            return 0;
        }
    }
    printf("-1\n");
    return 0;
}