#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define pb push_back
#define mp make_pair

struct Event {
    int t;
    int type;
    int x;

    Event() {
    }

    Event(int tx, int typex, int xx):
        t(tx),type(typex),x(xx){}

    inline bool operator<(const Event &other) const {
        return make_pair(t, type) < make_pair(other.t, other.type);
    }
};

const int N = 300005;
int wx[N];
int wy[N];

int main() {
    int ans = 0;
    int n, m, k;
    scanf("%d%d%d", &n, &m, &k);
    set<int> f[2];
    for (int i = 1; i < m; i++) f[0].insert(i);
    for (int i = 1; i <= m; i++) f[1].insert(i);
    vector<Event> e;
    for (int i = 1; i <= k; i++) {
        int a, b;
        scanf("%d%d", &a, &b);
        e.push_back(Event(a, 1, i));
        e.push_back(Event(b, -1, i));
    }
    e.push_back(Event(n, 0, 0)); /// dummy
    sort(e.begin(), e.end());
    for (int i = 0; i < (int)e.size(); i++) {
        if (i == (int)e.size() - 1) continue;
        Event cur = e[i];
        if (cur.type == 1) {
            for (int i = 0; i < 2; i++) {
                if (!f[i].empty()) {
                    wx[cur.x] = i;
                    wy[cur.x] = *f[i].begin();
                    f[i].erase(f[i].begin());
                    break;
                }
            }
        } else if (cur.type == -1) {
            f[wx[cur.x]].insert(wy[cur.x]);
        }
        bool bad = (f[1].find(m) == f[1].end());
        if (bad) {
            ans += e[i + 1].t - e[i].t;
            //cout << "bad " << e[i].t << " ... " << e[i+1].t << endl;
        }
    }
    printf("%d\n", ans);
    return 0;
}
